/*
 * National Semiconductor Corporation Gnu General Public License for 
 *
 *    VTest4Linux
 *
 * (GPL License with Export Notice)
 *
 * Copyright (c) 2001 
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted under the terms of the GNU General 
 * Public License as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later version  
 *
 * In addition to the terms of the GNU General Public License, neither 
 * the name of the National Semiconductor Corporation nor the names of 
 * its contributors may be used to endorse or promote products derived  
 * from this software without specific prior written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE, 
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE. See the GNU General Public License for more details. 
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (June 22, 2001>) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
 *
 * You should have received a copy of the GNU General Public License 
 * along with this file; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 */
 
/*
	by Phat Ho
	08/08/2000 Enjoy modifying the source code "button.c" to handle multiple
		set of radio buttons, every set must have id's aligned with 
		256 (0x100) boundaries
	12/11/2000 Finish adding digital video, requires the patcedh geode_v 
                and realmagic installation in /sigma
	        Need /sigma/bravhart.pes
	12/15/2000 change decoder subaddr 9 from 0 to 84 for SVideo for high quality
	   Need to add control to subaddr 88 to power down unused analog channel
	02/12/2001 Version 0.1.2 with new GUI

	02/20/2001 Version 0.1.3 clean up 
	03/09/2001 Version 0.1.5
	03/28/2001 Version 1.0.1 PAL, CC use -pal
			requires the links 
				/cygnus/sigma/NetStream2000 
			  	/cygnus/geode_v4l2
	04/13/2001 Version 1.0.2 DVIP support, sharpness key i,o
	05/07/2001 Version 1.0.3 Enhance the close caption decoding
				Clean up
	by Wei-ling
	12/19/2001 Version 1.0.4 Add paus, stop, and play for clip file play
                               Change Web button to MPEG
                               Add IR key: ch+/-, val+/-, pause, stop, and
                               play key
	01/09/2002 Version 1.0.5: Fix bugs
      02/08/2002 Version 1.0.6: Added error returns for all driver functions
*/
 
#include <sys/time.h>  
#include <sys/types.h> 
#include <sys/stat.h>
#include <sys/ioctl.h> 
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>
#define MWINCLUDECOLORS
#ifdef __cplusplus
extern "C" {
#endif
#include "windows.h"
#include "wintern.h"		/* for MwRegisterFdInput*/
#include "wintools.h"
#include "device.h"
#include "wintern.h"		/* for MwSetDesktopWallpaper*/
#ifdef __cplusplus
}
#endif
//===============================
/* These are needed to use the V4L2 driver */
#include <linux/fs.h>
#include <linux/kernel.h>
#include <linux/videodev.h>  /* Video for Linux Two */
#include <linux/soundcard.h>
#include <string.h>
//===============================
/* dependency */
//#include "/cygnus/NSC_API-1.00pre/include/VMW.h"
//#include "/cygnus/geode_v4l2/ioctl_geode_v.h"
#include <linux/ioctl_geode_v.h>
//#include "/cygnus/sigma/NetStream2000/include/fmp.h" 
#include <fmp.h> 
#include "vtest.h"

// Globals -- default state
int videostd = VIDEOSTD_NTSC; 	/* option -pal to set to VIDEOSTD_PAL */
int gQuit = 0;			/* option -q to set to 1 */
int resolutionY = 480;		/* screen height, changed by option -pal */
int resolutionX = 720; 		/* screen width */
int vbi107 = 0;			/* use 1.0.7 vbi style */
int capture = 0;
/* top menu/buttons location */
#define menuoffsetX	((resolutionX-640)/4)  

/* logo display, use alpha blending */
int gLogo = 0;
RECT  gAlphaRect,gLogoRect;
int logoCounter = 0;

/* pattern display */			
int gPattern = 0;

/* Close Caption display */
int vbi = -1;						/* driver instance */
unsigned char mem_display[2][CCDISPLAY_H][CCDISPLAY_W];	/* close caption buffer */
unsigned char mem_nondisplay[2][CCDISPLAY_H][CCDISPLAY_W];
COLORREF ccTextColor = WHITE;
int gOSDcount = 0;			/* CC interuption counter */
int gOSDenable = 0;			/* enable close caption sync */
BOOL gOSD = FALSE;			/* On Screen Display */
BOOL gCCbg = FALSE;			/* CC back ground mode */
int ccCharWidth2;			/* cc column width */
int ccCharWidth;			/* cc column width */
int ccCharHeight;			/* cc row height */
RECT ccBox = {0,0,0,0};			/* cc display area */
int ClearCC = 0;			/* flag to clear the screen before drawing */
int gVbiSignal = 0;			/* signal counter */
/* mpeg */
int gMpegMode = MPEG_CLOSE;		/* mpeg engine state */
int mpegPlaying = 0;			/* mpeg enable */
char mpgFilename[128] = "/cygnus/sigma/opera9.mpg";	/* mpeg secondary file */
int streamType = FMPF_SYSTEM;		/* mpeg secondary file type */
int fileIndex = 3;
int PreviewEnable = 0;

/* audio */
int muting = 0;				/* mute setting */
int volumes[4] = { 15,95,95,30 }; 	/* preset volume for video sources */
int audioselection = 0;			/* audio source selection */
int volume = 50;			/* main volume setting */

/* video */
int gChNum = 36;			/* preset tuner channel */
int gScaleVideo = 0;			/* video scale mode */
int gVidSelection = VID_COMPOSITE;	/* video source selection */

/* status, console and debug */
char mainstr[80];			/* console text buffer */
int ttyfd = -1;				/* tty device instance */
int xpos = STATUSMARGIN_X;		/* console cursor x position */
int ypos = STATUSMARGIN_Y;		/* console cursor y position */
int nCharWidth, nCharHeight;		/* console character display size */
COLORREF gStatusColor = CYAN;		/* console text color */

/* windows */
HWND gHwnd = NULL; 			/* desktop window */
HWND gDisplayHwnd = NULL; 		/* video display window */
HWND gStatusHwnd = NULL; 		/* console */
HWND gPrefHwnd = NULL;			/* preference window */
HWND digit1wnd,digit2wnd;		/* channel number display windows */

/* gui control */
int gShowPref = 0;			/* preference window enable */

/* timers */
int mainTimer = 100;			/* long period timer counter */
int channelCounter = 0;			/* 2-digit channel restore timer */
//------------------------------

//---------------------------------------------- 
//for Sojan request, log the settings here so we can issue ioclt calls
int gDecoderX = 0;
int gDecoderY = 0;
int gDecoderW = resolutionX;
int gDecoderH = resolutionY;

int gOverlayX = 0;
int gOverlayY = 0;
int gOverlayW = resolutionX;
int gOverlayH = resolutionY;

//---------------------------------------------- 

/* driver interface section */

/* deploy an alpha blend window, wnum, at the rectangle rc */
int SetAlphaBlend(int wnum,RECT rc,int subcolor,int alphaval,int xoffs,int yoffs)
{
     int retval=0;
     retval = set_alpha_blend_info(wnum,rc.left,rc.top, rc.right-rc.left, 
              rc.bottom-rc.top, 0, alphaval & 0xFF, (alphaval >> 8) & 0xFF, 
              (alphaval < 0) ? 0 : 1, subcolor);
	return retval;
}

/* set the video sharpness */
int ChangeShapness(int amount)
{
static int sharp = 12; /* default setting */
char tmp[80];
	sharp += amount;
	if(sharp < 0)
		sharp = 0;
	else if(sharp > 15)
		sharp = 15;
	sprintf(tmp,"sharp=%d\r\n", sharp);
	StatusOutStr(tmp);
	return (video_sharpness((16-sharp)&15)); //try to make the scale linear	
}

//----------------------------------------------

/* application options
	-quit 	open, init and close the driver, then exit
	-pal	run video in pal standard
	-tune ch, set the startup tuner channel
	-tsfile mpegfile, assign secondary mpeg file as a tsfile
	-vobfile mpegfile, assign secondary mpeg file as a vobfile
	-sysfile mpegfile, assign secondary mpeg file as a sysfile */	
void usage()
{
  printf("vtest [-quit][-pal] [-tune ch] [-tsfile|-vobfile|-sysfile mpegfile] \n");
}

/* this is the very first user function being called by Microwindows 
all the options are parsed here */
int
MwUserInit(int argc, char **argv)
{
	int	args = 0;

	while( argc > ( args + 1 ) )
	{
		args++;
		if( strcmp(argv[args],"-tune") == 0 )
		{
			if( argc > args )
			{
			  args++;
			  gChNum = atoi(argv[args]);
			  sprintf(mainstr,"tuning to channel %d\r\n", gChNum );
			  printf("%s",mainstr);
			}
			else
			{
				usage();
				exit(1);
			}
		}
		else
		if( strcmp(argv[args],"-input") == 0 )
		{
			if( argc > args )
			{
			  args++;
			  gVidSelection = atoi(argv[args]);
			  if(gVidSelection < 0 || gVidSelection > VID_DIGITAL)
			  gVidSelection = VID_TUNER;
			  sprintf(mainstr,"set input %d\r\n", gVidSelection );
			  printf("%s",mainstr);
			}
			else
			{
				usage();
				exit(1);
			}
		}
		else if( strcmp(argv[args],"-tsfile") == 0 )
		{
			if( argc > args )
			{
				args++;
				strcpy(mpgFilename,argv[args]);
				streamType = FMPF_TRANSPORT;
			}
			else
			{
				usage();
				exit(1);
			}
		}
		else if( strcmp(argv[args],"-vobfile") == 0 )
		{
			if( argc > args )
			{
				args++;
				strcpy(mpgFilename,argv[args]);
				streamType = FMPF_DVD;
			}
			else
			{
				usage();
				exit(1);
			}
		}
		else if( strcmp(argv[args],"-sysfile") == 0 )
		{
			if( argc > args )
			{
				args++;
				strcpy(mpgFilename,argv[args]);
				streamType = FMPF_SYSTEM;
			}
			else
			{
				usage();
				exit(1);
			}
		}
		else if( strcmp(argv[args],"-pal") == 0 )
		{
			videostd = VIDEOSTD_PAL;
		}
		else if( strcmp(argv[args],"-quit") == 0 )
		{
			gQuit = 1;
		}
	}
	
	/* set the screen resolution by video standard */
	if(videostd == VIDEOSTD_NTSC)
	{
		gOverlayH = gDecoderH = resolutionY = 480;
	}
	else /* PAL */
	{
		gOverlayH = gDecoderH = resolutionY = 576;
	}
	
	return 0;
}

/* register the different window classes which are used in this application */
int
RegisterAppClass(void)
{
	WNDCLASS	wc;

	MwRegisterButtonControl(NULL);
	MwRegisterEditControl(NULL);
	MwRegisterListboxControl(NULL);
	MwRegisterProgressBarControl(NULL);
	MwRegisterStaticControl(NULL);

	/* register main window class */
	wc.style = CS_DBLCLKS | CS_VREDRAW | CS_HREDRAW;
	wc.lpfnWndProc = (WNDPROC)MainWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = 0;
	wc.hIcon = 0;
	wc.hCursor = 0;
	wc.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName =  APPCLASS;
	RegisterClass( &wc);

	/* register status window class */
	wc.lpfnWndProc = (WNDPROC)StatusWndProc;
	wc.lpszClassName =  STATUSCHILD;
	RegisterClass( &wc);
	
	/* register display window class */
	wc.lpfnWndProc = (WNDPROC)DisplayWndProc; 
	wc.lpszClassName =  DISPLAYCHILD;
	RegisterClass( &wc);
	
	/* register preference window class */
	wc.lpfnWndProc = (WNDPROC)PrefWndProc;
	wc.lpszClassName =  PREFCHILD;
	RegisterClass( &wc);

	return 1;
}

/* Making the windows */

/* main window rect, change to adjust */
#define mainX		0
#define mainY		0
#define mainW		(resolutionX-mainX)
#define mainH		(resolutionY-mainY)

/* initial video window rect */
#define videoX		0
#define videoY		0
#define videoW		mainW
#define videoH		(mainH-videoY-videoY) /* center vertically */

/* location and size of preference and status windows */
#define PANELX 	96
#define PANELY	120
#define PANELW 	360
#define PANELH	90
#define STATUSY	198

#define radioH		13
#define checkH		13
#define pushH		20
		
HWND
CreateAppWindow(void)
{
#define WS_PLAIN (WS_OVERLAPPED)

	HWND	hwnd,itemhwnd,tmphwnd;;
	HDC	hdc;
	int 	x, y, X, Y;
	RECT 	r;
	
	GetWindowRect(GetDesktopWindow(), &r);
		
	SetAlphaBlend(alpha0,r,0,-1,0,0);
	SetAlphaBlend(alpha2,r,0,-1,0,0);
	SetAlphaBlend(alpha1,r,0,-1,0,0);
	
	/* create the main application window */
	gHwnd = hwnd = CreateWindowEx(0L, APPCLASS,
		"STB Video Test Suite",
		WS_PLAIN | WS_VISIBLE,
		mainX, mainY,
		mainW, mainH,
		NULL, (HMENU)3, NULL, NULL);

	if(gHwnd) 
	{

		//create the video window
		
		gDisplayHwnd = CreateWindowEx(0L, DISPLAYCHILD,
			"display",
			WS_CHILD | WS_VISIBLE, 
			videoX, videoY, 
			videoW, videoH,
			hwnd, (HMENU)IDC_DISPLAY, NULL, NULL);
			
		hdc = GetDC(gDisplayHwnd);
		SetBkColor(hdc,CCBKCOLOR);
	    	SetBkMode(hdc, OPAQUE);
		SetTextColor(hdc, ccTextColor);	
		SelectObject(hdc, GetStockObject(OEM_FIXED_FONT));
		SetRect(&r, 0, 0, 0, 0);
		
		/* prepare the display size for close caption text */
		ccCharHeight = DrawText(hdc, "m", 1, &r, DT_CALCRECT);
		ccCharWidth2 = ccCharWidth = r.right;
		ccCharHeight = r.bottom;
		ReleaseDC(gDisplayHwnd, hdc);
		
		/* setup the top row buttons */
		#define ROW1_ITEMS	7		/* number of buttons */
		#define ROW1_GAPW	20		/* the gap in between items */
		#define ROW1_ITEM_W ((640-100-(ROW1_GAPW*(ROW1_ITEMS+1)))/ROW1_ITEMS)
		#define ROW1_ITEM_H	20	
		#define ROW1_X		(ROW1_GAPW+10+menuoffsetX) 
		#define ROW1_Y		40		/* first button offset */
		
		X = x = ROW1_X; Y = y = ROW1_Y;
		tmphwnd = CreateWindowEx(0L, "BUTTON", 
			"",//tuner
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_BITMAP, 
			x, y, ROW1_ITEM_W, ROW1_ITEM_H, //30,40,54,20
			hwnd, (HMENU)IDC_TUNER, NULL, NULL);
		SendMessage(tmphwnd,BM_SETIMAGE,(int)&image_tv8a,0);
		 
		x += (ROW1_ITEM_W+ROW1_GAPW); 
		tmphwnd = CreateWindowEx(0L, "BUTTON",
			"",//Video
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_BITMAP, 
			x, y, ROW1_ITEM_W, ROW1_ITEM_H, 
			hwnd, (HMENU)IDC_VIDEO, NULL, NULL);
		SendMessage(tmphwnd,BM_SETIMAGE,(int)&image_video8,0);
		
		x += (ROW1_ITEM_W+ROW1_GAPW);
		tmphwnd = CreateWindowEx(0L, "BUTTON",
			"",//SVideo
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_BITMAP,
			x, y, ROW1_ITEM_W, ROW1_ITEM_H,
			hwnd, (HMENU)IDC_SVIDEO, NULL, NULL);
		SendMessage(tmphwnd,BM_SETIMAGE,(int)&image_svideo8,0);
		
		x += (ROW1_ITEM_W+ROW1_GAPW);
		tmphwnd = CreateWindowEx(0L, "BUTTON",
			"",//Digital
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_BITMAP,
			x, y, ROW1_ITEM_W, ROW1_ITEM_H,
			hwnd, (HMENU)IDC_DIGITAL, NULL, NULL);
		SendMessage(tmphwnd,BM_SETIMAGE,(int)&image_digital8,0);
		
		x += (ROW1_ITEM_W+ROW1_GAPW);
		tmphwnd = CreateWindowEx(0L, "BUTTON",
			"",//Streaming
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_BITMAP,
			x, y, ROW1_ITEM_W, ROW1_ITEM_H,
			hwnd, (HMENU)IDC_STREAM, NULL, NULL);
		SendMessage(tmphwnd,BM_SETIMAGE,(int)&image_mpeg8,0);
		
		x += (ROW1_ITEM_W+ROW1_GAPW);
		tmphwnd = CreateWindowEx(0L, "BUTTON",
			"",//Pref
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | BS_BITMAP,
			x, y, ROW1_ITEM_W, ROW1_ITEM_H,
			hwnd, (HMENU)IDC_PREF, NULL, NULL);
		SendMessage(tmphwnd,BM_SETIMAGE,(int)&image_pref8,0);
		
		x += (ROW1_ITEM_W+ROW1_GAPW)+(resolutionX-640);
		digit2wnd = CreateWindowEx(0L, "STATIC",
			"",
			WS_CHILD | WS_VISIBLE | SS_SIMPLE,
			x, y-10, ROW1_ITEM_W/2, ROW1_ITEM_H*2,
			hwnd, (HMENU)IDC_CHNUM10x, NULL, NULL);
		SendMessage(digit2wnd,STM_SETIMAGE,(int)&image_0,0);
		
		digit1wnd = CreateWindowEx(0L, "STATIC",
			"",
			WS_CHILD | WS_VISIBLE | SS_SIMPLE,
			x+ ROW1_ITEM_W/2, y-10, ROW1_ITEM_W/2, ROW1_ITEM_H*2,
			hwnd, (HMENU)IDC_CHNUM1x, NULL, NULL);
		SendMessage(digit1wnd,STM_SETIMAGE,(int)&image_0 ,0);

		gPrefHwnd = CreateWindowEx(0L, PREFCHILD,
			"", //pref panel
			WS_BORDER | WS_CHILD /*| WS_VISIBLE*/,
			PANELX,PANELY,  
			PANELW,PANELH, 
			hwnd, (HMENU)IDC_PREFPANEL, NULL, NULL);
		gStatusHwnd = CreateWindowEx(0L, STATUSCHILD,
			"*************** Welcome to Vtest for Linux *************\n",
			WS_BORDER | WS_CHILD /*| WS_VISIBLE*/,
			PANELX,STATUSY,  
			PANELW,PANELH, 
			hwnd, (HMENU)IDC_STATUS, NULL, NULL);

						
	//group2 -- In the preference window
		#define BUTTONX	10
		#define BUTTONY	4
		#define ITEMPERROW 4
		#define BUTTOBW	(((PANELW-BUTTONX-BUTTONX)/ITEMPERROW)-BUTTONX)
		Y = BUTTONY;
		x = BUTTONX; y = Y;	
		CreateWindowEx(0L, "BUTTON",
			"Mute",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y+4, BUTTOBW, checkH,
			gPrefHwnd, (HMENU)IDC_MUTE, NULL, NULL);
		x += BUTTOBW+BUTTONX;
		CreateWindowEx(0L, "BUTTON",
			"vol down",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, BUTTOBW, pushH,
			gPrefHwnd, (HMENU)IDC_VOLUMEDOWN, NULL, NULL);
		x += BUTTOBW+BUTTONX;
		CreateWindowEx(0L, "BUTTON",
			"vol up",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, BUTTOBW, pushH,
			gPrefHwnd, (HMENU)IDC_VOLUMEUP, NULL, NULL);
		x += BUTTOBW+BUTTONX;
		CreateWindowEx(0L, "BUTTON",
			"Close",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, BUTTOBW, pushH,
			gPrefHwnd, (HMENU)IDC_CLOSEPREF, NULL, NULL);
		Y += pushH+BUTTONY; 
//----------		
		x = BUTTONX; y = Y;	
		CreateWindowEx(0L, "BUTTON",
			"CC",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, BUTTOBW, checkH,
			gPrefHwnd, (HMENU)IDC_CLOSECAPTION, NULL, NULL);
		x += BUTTOBW+BUTTONX;
		CreateWindowEx(0L, "BUTTON",
			"Logo",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, BUTTOBW, checkH,
			gPrefHwnd, (HMENU)IDC_LOGO, NULL, NULL);
		x += BUTTOBW+BUTTONX;
		CreateWindowEx(0L, "BUTTON",
			"Half screen",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, BUTTOBW, checkH,
			gPrefHwnd, (HMENU)IDC_SCALE, NULL, NULL);
		x += BUTTOBW+BUTTONX;
		CreateWindowEx(0L, "BUTTON",
			"Exit",
			BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
			x, y, BUTTOBW, pushH,
			gPrefHwnd, (HMENU)IDC_EXIT, NULL, NULL);
		Y += checkH+BUTTONY+3; 
//----------		
		x = BUTTONX; y = Y;	
		itemhwnd = CreateWindowEx(0L, "BUTTON",
			"Menu",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, BUTTOBW, checkH,
			gPrefHwnd, (HMENU)IDC_CINEMA, NULL, NULL);
		SendMessage(itemhwnd,BM_SETCHECK,1,0); //to show the menu bar
		x += BUTTOBW+BUTTONX;	
		CreateWindowEx(0L, "BUTTON",
			"DVIP",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE , //| WS_DISABLED
			x, y, BUTTOBW, checkH,
			gPrefHwnd, (HMENU)IDC_DVIP, NULL, NULL);
		x += BUTTOBW+BUTTONX;
		CreateWindowEx(0L, "BUTTON",
			"Status",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, BUTTOBW, checkH,
			gPrefHwnd, (HMENU)IDC_STATUSWND, NULL, NULL);
		x += BUTTOBW+BUTTONX;
		CreateWindowEx(0L, "BUTTON",
			"Pattern",
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			x, y, BUTTOBW, checkH,
			gPrefHwnd, (HMENU)IDC_PATTERN, NULL, NULL);

		/* determine TE size from font*/
		hdc = GetDC(NULL);
		SelectObject(hdc, GetStockObject(SYSTEM_FIXED_FONT));
		SetRect(&r, 0, 0, 0, 0);
		nCharHeight = DrawText(hdc, "m", 1, &r, DT_CALCRECT);
		nCharWidth = r.right;
		ReleaseDC(NULL, hdc);
	}

	return gHwnd;
}

/* display tv tuner channel number */
void SetChNum(int chnum)
{
static MWIMAGEHDR* numbers[10] = { /* the digit display array */
	&image_0,
	&image_1,
	&image_2,
	&image_3,
	&image_4,
	&image_5,
	&image_6,
	&image_7,
	&image_8,
	&image_9 };
	
	if(chnum < 0) /* no display */
	{
		ShowWindow(digit1wnd,SW_HIDE );
		ShowWindow(digit2wnd,SW_HIDE );
		ShowMenuBar(ITEM_ON);
	}
	else
	{
		/* suppress zero leading */
		ShowWindow(digit1wnd,SW_SHOW );
		ShowWindow(digit2wnd,SW_SHOW );
		SendMessage(digit1wnd,STM_SETIMAGE,(int)numbers[chnum%10],0);
		if(chnum < 10)
		{
		  SendMessage(digit2wnd,STM_SETIMAGE,(int)&image_blank,0);
		}
		else
		{
		  SendMessage(digit2wnd,STM_SETIMAGE,(int)numbers[chnum/10],0);
		}
		ShowMenuBar(ITEM_ON);
	}
}

/* set tv tuner channel */
int SetChannel(int chnum)
{
	int 	rc = 0;
	if(chnum == -1)
		chnum = 99;
	chnum %= 100;
	
	/* turn off close caption before switching */
	if(vbi >= 0)
	{
		ShowCloseCaption(0);
		gOSDcount = 1;
	}
	
	/* now instruct the driver to switch */
	set_chan(chnum);
	{					
		gChNum = chnum;
		/* update the display*/
		SetChNum(gChNum);
	}
	return rc;
}

/* structure to communicate with debug feature in the driver */
typedef struct diagnostic_info
{
	int		cmd;
	int		arg1;
	int		arg2;
	int		result[64];
} diagnostic_info_t;

/* when the char '%' is received from the keyboard 
local input is toggle on/off
This designed to add a text input interface to the app
mainly for debugging */
 
int ParseLocalInput(char ch)
{
	static char localcmd[256];
	static int localindex = 0;
	char cmd[10],tmp[80];
	int items,index;
	int error,count = 1;
	int vout = 0;
	diagnostic_info_t diag_info;
	
	/* stop local input */
	if(localindex == 0 && (ch == '%' || ch == '.'))
		return 0; //end local input
		
	/* buffer all keys to localcmd[] */
	if(ch != '\r')
	{
		if(ch == '\b' && localindex)
			--localindex;
		else
			localcmd[localindex++] = ch;
	}
	else
	{	
	  /* force new line on the console status window */
	  EmOutChar(gStatusHwnd, '\r');
	  EmOutChar(gStatusHwnd, '\n');
	  localcmd[localindex++] = 0;
		
	  diag_info.arg2 = 1; //minimum count
	  items = sscanf(localcmd,"%s %X %X",
          cmd,&diag_info.arg1,&diag_info.arg2);
	  error = 0;
	  if(items >= 2 && cmd[0] == 'r')
	  {
	    count = (items == 2) ? 1 : diag_info.arg2;
	    switch(cmd[1])
	    {
		case 'd':
			diag_info.cmd = READ_DEC;
			break;
		case 'p':
			diag_info.cmd = READ_VIP;
			break;
		case 'v':
			diag_info.cmd = READ_VID;
			break;
		case 'r':
			diag_info.cmd = READ_REG;
			break;
		default:
			error = 1;
			break;
	    }	
	  }
	  else if(items == 3 && cmd[0] == 'w')
	  {
		switch(cmd[1])
		{
		  case 'd':
			diag_info.cmd = WRITE_DEC;
			break;
		  case 'p':
			diag_info.cmd = WRITE_VIP;
			break;
		  case 'v':
			diag_info.cmd = WRITE_VID;
			break;
		  case 'r':
			diag_info.cmd = WRITE_REG;
			break;
		  default:
			error = 1;
			break;
		}
			count = 1;	
	  }
	  else
	  {
		StatusOutStr(localcmd);
		error = 1;
	  }
	  if( !error )
	  {
		vout=open("/dev/vout", O_WRONLY);
		if(vout < 0)
		  StatusOutStr(" Cannot Open file /dev/vout");
		else
		{
#if 0
		  if(0 > ioctl(vout, GEODE_IOCTL_DIAG, &diag_info))
			StatusOutStr(" -- error");
		  else
#endif
		  {
		    if(count == 1)
		    {
		          sprintf(tmp," -- %8.8X",diag_info.result[0]);
			  StatusOutStr(tmp);
		    }
		    else
		    {
		      for(index = 0; index < count; index++)
		      {
		        if(cmd[1] != 'd') //4bytes
		        {
		          if(index && (index&7)==0)
		            StatusOutStr("\r\n");	
		          sprintf(tmp," %8.8X",diag_info.result[index]);
		        }
		        else //1byte
	   	        {
			       if(index && (index&15)==0)
			         StatusOutStr("\r\n");	
			       sprintf(tmp," %2.2X",diag_info.result[index]);
		        }
		        StatusOutStr(tmp);
		       }
	             }
		    }
	         close(vout);	
	        }
           }
	localindex = 0;
      }
      return 1; //more
}

/* console status window handler */
LRESULT CALLBACK
StatusWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
static int escapemode = 0;
	unsigned char	ch;
	HDC		hdc;
	RECT		rc;
	PAINTSTRUCT	ps;
   	char	tmp[8];
	PWNDCLASS pClass;
	WNDPROC WndProc ;
	
	/* flag to accept key as local input */
static int gLocalInput = 0;
	
	pClass = MwFindClassByName("EDIT");
	WndProc = pClass->lpfnWndProc;
	switch(msg) {
	case WM_CREATE: /* create the tty dev */
		ttyfd = CreatePtyShell();
		MwRegisterFdInput(hwnd, ttyfd);
		xpos = STATUSMARGIN_X;
		ypos = STATUSMARGIN_Y;
		break;

	case WM_DESTROY: /* close tty device */
		MwUnregisterFdInput(hwnd, ttyfd);
		ClosePtyShell(ttyfd);
		break;

	case WM_CHAR:
		ch = (char)wp;
		/* echo half duplex if CreatePtyShell() failed*/
		if(ttyfd == -1) {
			EmOutChar(hwnd, ch);
			if(ch == '\r')
				EmOutChar(hwnd, '\n');
		} 
		else if(gLocalInput) /* parse the input stream */
		{
			gLocalInput = ParseLocalInput(ch);
			if(!gLocalInput)
				StatusOutStr(" end local input\r\n");
			else
			{
				EmOutChar(hwnd, ch);
				if(ch == '\r')
					EmOutChar(hwnd, '\n');
			}
		}
		else if(ch == '%' ) /* turn on local input */
		{
			gLocalInput = 1;
			StatusOutStr("begin local input\r\n");
		}
		else /* direct input to the tty device */
		{
			WritePtyShell(ttyfd, (char*)&ch, 1);
			if(escapemode == 0 && ch == 0x1b) //escape
			{
				escapemode = 0x1b;
			}
			else
			{
				switch(escapemode)
				{
				case 0x1b:
				      if(ch == 0x1b)
					PostMessage(gHwnd, WM_CLOSE, 0, 0);	
				      else if(ch != 0x5B)
				      {
					sprintf(tmp,"-%2.2X-",ch);
					StatusOutStr(tmp);
					escapemode = 0;
				      }
				      else
					escapemode = ch;
				      break;
				case 0x5B:
					switch(ch)
					{
					case 0x41: //up
					case 0x42: //down
	StatusOutStr("\r                                                 \r");
						break;
					case 0x43: //left
					case 0x44: //right
						break;
					default:
						sprintf(tmp,"-%2.2X-",ch);
						StatusOutStr(tmp);
						break;
					}
					escapemode = 0;;
					break;
				}
			}
		}
		break;

	case WM_FDINPUT: /* display tty input */
		if(mainstr[0] != 0)
		{
			StatusOutStr(mainstr);
			mainstr[0] = 0;
		}
		else
		if(ReadPtyShell(ttyfd, (char*)&ch, 1) == 1)
			EmOutChar(hwnd, ch);
		break;

	case WM_PAINT: /* draw the 3D window frame */
		hdc = BeginPaint(hwnd, &ps);
		GetClientRect(hwnd, &rc);
		Draw3dInset(hdc, 0, 0, rc.right-rc.left, rc.bottom-rc.top);
		EndPaint(hwnd, &ps);
		break;

	default:
		return DefWindowProc(hwnd, msg, wp, lp);
	}
	return 0;
}

static int Altpress = 0;

/* video window handler */
LRESULT CALLBACK
DisplayWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static int digit2 = 0;
	HDC		hdc;
	RECT		rc;
	PAINTSTRUCT	ps;
	HBRUSH		gOvlBrush;
	POINT		p1 = {0,0};
	char		key;
	RECT panelRect1 = { 0,0,resolutionX,80 };
	/* pattern drawing */
	int horzn;
	int thichness;
	int patternsize;
	int patterncolor;
	int patternwidth;
      int retval = 0;
	
	switch(msg) {
	case WM_TIMER:
		break;
	case WM_LBUTTONUP:
	case WM_CHAR:
	      key =  LOBYTE (wp);
              if (key == 0x2f) { 
                 Altpress = 1;
                 break;
              }
              if (Altpress == 0) {		
		/* translate number key into tuner channel setting */
		if(key >= '0' && key <= '9' && gVidSelection == VID_TUNER)
		{
			if(channelCounter)
			{
				SetChannel((digit2*10)+(key - '0'));
				channelCounter = 0; /* both digits have arrived */
			} 
			else
			{
			  channelCounter = 4; //set delay to wait for the 2nd digit
			  digit2 = (key - '0');
			  SetChNum(digit2);
			}
		}
		else switch(key) /* short cut key to operate the app */
		{
		   case '=':
		   case '+': 
                       if(gVidSelection == VID_TUNER)
                           SetChannel(gChNum+1); 
                        break;
		   case '\\':	
		   case '-': 
                        if(gVidSelection == VID_TUNER)
                           SetChannel(gChNum-1); 
                        break;
		   case 't':    
                        if (SelectVideoSource(SW_SHOW,VID_TUNER,0)== -1)
                           retval = -1;
                        break; 	
		   case 's': 
                        if (SelectVideoSource(SW_HIDE,VID_SVIDEO,0)==-1)
                           retval = -1; 
		        break; 	
		   case 'v': 
                        if (SelectVideoSource(SW_HIDE,VID_COMPOSITE,0) == -1)
		          retval = -1; 
			break; 	
		  case 'd': 
                        if(fileIndex !=3 && gMpegMode != MPEG_CLOSE) {  
                           if (PlayMpeg(MPEG_CLOSE, 0) == -1) {
                               retval = -1;
                               break;
                           }
                         }
                         fileIndex = 3; 
                         if (SelectVideoSource(SW_HIDE,VID_DIGITAL,0)== -1) {
		             PostMessage(gHwnd, WM_CLOSE, 0, 0); 
			       retval = -1; 
                         }
                         break;
		   case 'w': 
                        if(fileIndex !=4 && gMpegMode != MPEG_CLOSE) {  
                           if (PlayMpeg(MPEG_CLOSE, 0) == -1) {
                               retval = -1;
                               break;
                           }
                         }
                         fileIndex = 4; 
                           if(SelectVideoSource(SW_HIDE,VID_DIGITAL,1)==-1)
			     retval = -1;  
                         break;
		   case 'p': ShowPref(ITEM_TOGGLE); break; 		
		   case 'l': SetLogo(ITEM_TOGGLE); break;			
		   case '>':	
		   case '.': 
                   case 0x10: //arrow-right or VAL+
                         SetAudio(audioselection,muting=0,1); break;
		   case '<':
		   case ',': 
                   case 0x0e: //arrow-left, or VAL-
                        SetAudio(audioselection,muting=0,-1); break;
		   case 'm': 
                        SetAudio(audioselection,muting = muting ? 0:1, 1); 
                        break;
		   case 'q': PostMessage(gHwnd, WM_CLOSE, 0, 0); break;
		   case '?':
		   case '/': ShowStatus(ITEM_TOGGLE); break;	
		   case ' ': ShowMenuBar(ITEM_TOGGLE); break; 
		   case 'h': ShowScale(ITEM_TOGGLE); break;
		   case 'c': ShowCloseCaption(ITEM_TOGGLE); break;
		   case 'n': SetDVIP(ITEM_TOGGLE); break;
		   case 'b': ShowPattern(ITEM_TOGGLE); break;
		   case 'i': ChangeShapness(-1); break;
		   case 'o': ChangeShapness(+1); break;
		   default: 
			break;
		 }
               } else { 
                      Altpress = 0;
                      switch (key) {
                        case '2': //Alt and 2 is Play key
                           if (gVidSelection == VID_DIGITAL) { 
                             if( gMpegMode==MPEG_PAUSE)
                               PlayMpeg(MPEG_PLAY,gMpegMode);
                             else {
                               if(fileIndex == 3)
                                 SelectVideoSource(SW_HIDE,VID_DIGITAL,0);  
                               else
                                 SelectVideoSource(SW_HIDE,VID_DIGITAL,1); 
                             }
                            }
                             break;
			case '5':  //Alt and 5 is STOP key in IR 
                           if (gVidSelection == VID_DIGITAL) { 
    			     if (gMpegMode == MPEG_PLAY)
                              PlayMpeg(MPEG_STOP,gMpegMode);
                           }
                           break;
                        case '6':  //Alt and 6 is PAUSE key in IR
                           if (gVidSelection == VID_DIGITAL) { 
    			     if ( gMpegMode == MPEG_PLAY )
                               PlayMpeg(MPEG_PAUSE,gMpegMode);
                           }
                           break;
                        case '7':
                             SetChannel(gChNum+1); break;
                        case '8':
                             SetChannel(gChNum-1); break;
                        default:
                           break;
                      } //end of switch
                   } 
                   if (retval == -1)
		       PostMessage(gHwnd, WM_CLOSE, 0, 0); 
		   break;
                           
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
		GetClientRect(hwnd, &rc);
		gOvlBrush = CreateSolidBrush(OVERLAY_KEY);
		
		/* fill the window with the overlay color key to display video */
		if(!gPattern) 
			FillRect(hdc, &rc, gOvlBrush);
		else /* draw the test pattern */ 
		{
			//SetTextColor (hdc,GetSysColor(COLOR_BTNFACE));
			thichness = 4;
			patternsize = 80;
			patterncolor = 1;
			patternwidth = thichness;
			for( horzn=719; horzn >= 0; horzn --)
			{
				if(patterncolor > 0)
				{ 	
					MoveToEx(hdc, horzn, 0, NULL);
					LineTo(hdc,horzn,576);
				}
				--patternsize;
				if(--patternwidth == 0)
				{
					patterncolor = ~patterncolor;
					patternwidth = thichness;
			
					if(patternsize <= 0)
					{
						patternsize = 80;
						if(++thichness > 4)
							thichness = 1;
					}
				}			
			}
		}
				
#if 0
		/* or show a bitmap screen for calibrating the display */
		DrawDIB(hdc, rc.left, rc.top, &image_B720x576cross);
#endif				
		DeleteObject(gOvlBrush);

		
		/* update the menu bar visibility */
		ShowMenuBar(ITEM_APPLY);
		if(!gScaleVideo)
		{
			gOvlBrush = CreateSolidBrush(BLACK);
			FillRect(hdc, &panelRect1, gOvlBrush); 
			DeleteObject(gOvlBrush);
		}
		
		/* if the logo is enable, display it */
		if(gLogo)
		{
			gLogoRect.left = rc.left + 4+LOGOX;
			gLogoRect.top = rc.top + 4+LOGOY;
			gLogoRect.right = gLogoRect.left + 239;
			gLogoRect.bottom = gLogoRect.top + 70;
			ClientToScreen(gDisplayHwnd,&p1);
			gAlphaRect.left = gLogoRect.left + p1.x;
			gAlphaRect.right = gLogoRect.right + p1.x;
			gAlphaRect.top = gLogoRect.top + p1.y;
			gAlphaRect.bottom = gLogoRect.bottom + p1.y;
			/* apply the opaque alpha window */
			SetAlphaBlend(alpha0,gAlphaRect,0,0x00FFFF,0,0);
			/* draw the logo from the bitmap file */
			DrawDIB(hdc, gLogoRect.left, gLogoRect.top, &image_nsc8);
			//bit 0 is used to synchronized the transition direction 
			gLogo |= 1; 
		}
		EndPaint(hwnd, &ps);
		break;
	default:
		return DefWindowProc( hwnd, msg, wp, lp);
		break;
	}
	return(retval);
}

/* -------------------------------------------------------------- 
     Close caption decoding 
   -------------------------------------------------------------- */  				
/* cc -- the delete to end command */
void DeleteToEnd(int row,int col,int mode, int channel)
{
	switch(mode)
	{
	case CC_PAINT: //paint
	case CC_RU2: // roll
	case CC_RU3:
	case CC_RU4:
		//update the display
		memset(&mem_display[channel][row][col],0,32-col);
		CCOutChar(0x10,row,col,channel,FALSE);
		break;
	case 1: //pop
		memset(&mem_nondisplay[channel][row][col],0,32-col);
		break;
	}
}

/*cc -- update display */
void UpdateDisplayFromMem(int channel)
{
	int row,col,col2;
	char c;
	
	/* for every non-zero row, display the text and clear to end */
	for(row = 0; row < CCDISPLAY_H; row++)
	{
		col2 = 0;
		for(col = 0; col < CCDISPLAY_W; col++)
		{
			c = mem_display[channel][row][col];
			if(c != 0)
			{
				CCOutChar(c,row,col,channel,TRUE);
				col2 = col+1;
			}
		}
		if(col2 < 32)
			CCOutChar(0x10,row,col2,channel,FALSE);	
	
	}


}

/* cc -- buffer or draw the non-special characters */
int CCInsert(int cc,int row,int col,int mode,int channel)
{
	char tmp[80];
	//static int popon = 0;
	//EmOutChar(gStatusHwnd,cc);
	//return 1;
	tmp[1] = 0;
	/*if( cc >= '0' && cc <= '9')
		EmOutChar(gStatusHwnd,cc);
	else*/
	if(cc >= ' ' && cc <= 'Z')
		EmOutChar(gStatusHwnd,cc);
	else if(cc >= 'a' && cc <= 'z')
		EmOutChar(gStatusHwnd,cc);
	else
	{			
		sprintf(tmp," %2.2X",cc); //what is this
		StatusOutStr(tmp);
	}
	switch(mode)
	{
	case CC_POP: //popup
		/*if(cc == 1)
		{
			popon = 1;
			return 0;
		}
		else 
		if(cc == 0)
		{
			popon = 0;
			return 0;
		}*/
		//if(popon)
		{	
			mem_nondisplay[channel][row][col] = (char)cc;
			//EmOutChar(gStatusHwnd,cc);
			return 1; //accept 1 character
		}
		/*else
		{
			//EmOutChar(gStatusHwnd,cc);
			return 0;
		}*/
		break;
	case CC_PAINT: //paint
	case CC_RU2: //rollup2
	case CC_RU3: //rollup3
	case CC_RU4: //rollup4
		mem_display[channel][row][col] = (char)cc;
		CCOutChar(cc,row,col,channel,TRUE);
		return 1;
		break;
	default:
		/* dump to debug window */
		break;
	}
	return 0;
}

/* roll up */						
void CCRollup(int lines, int baserow, int channel)
{
	HDC	hdc;
	RECT	rc;
	HBRUSH 	gOvlBrush;	
	COLORREF ovlcolor = OVERLAY_KEY;
	//int height = ccCharHeight*1;
	//int height2= ccCharHeight*lines;
	
	if(baserow < lines) return;
	
	int left = CCLEFT + (channel*300);
	int basetop = CCTOP+(ccCharHeight*baserow);
	int top = basetop-((lines-1)*ccCharHeight);
	int width = ccCharWidth2*CCDISPLAY_W;  
/*
	BitBlt(hdc, STATUSMARGIN_X, STATUSMARGIN_Y, rc.right-STATUSMARGIN_X*2,
		rc.bottom-nCharHeight-STATUSMARGIN_Y*2,
		hdc, STATUSMARGIN_X, nCharHeight+STATUSMARGIN_Y, SRCCOPY);
*/
	/* set the base row rectangle */
	SetRect(&rc, left, basetop,
		left+width, basetop+ccCharHeight);

	hdc = GetDC(gDisplayHwnd);
	BitBlt(hdc, left, top, width ,ccCharHeight*(lines-1),
		hdc, left,top+ccCharHeight, SRCCOPY);
	
	gOvlBrush = CreateSolidBrush(ovlcolor);
	FillRect(hdc, &rc,gOvlBrush);
	DeleteObject(gOvlBrush);
	
	ReleaseDC(gDisplayHwnd, hdc);
}

/* change the total number of row of display text in roll up mode */
void SetRollup(int lastmode,int newmode, int baserow, int channel)
{	
	if(lastmode < 2)
	{
		CCOutChar(0,0,0,channel,FALSE);
		memset(mem_display[channel],0,CCDISPLAY_H*CCDISPLAY_W);
		memset(mem_nondisplay[channel],0,CCDISPLAY_H*CCDISPLAY_W);
	}
	else
	{
		while(lastmode-- > newmode)
		{	
			CCOutChar('\r',baserow - lastmode,0,channel,FALSE);
			memset(mem_display[channel][baserow - lastmode],0,32);
		}	
	}
}


/* cc -- draw a character or clear the text screen */
void CCOutChar(int ch, int row, int col, int channel, BOOL bDraw)
{
	HDC	hdc;
	RECT	rc;
	HBRUSH 	gOvlBrush; 
	int ccxpos;
	int ccypos;
	COLORREF ovlcolor = OVERLAY_KEY;
	int	charWidth = ccCharWidth2;
	
	/* default to a single character cell */
	int height = ccCharHeight;
	int width = charWidth; 

	POINT p1 = {0,0};
	
	/* clear the display if required */
	if(ClearCC)
	{
		ClearCC = FALSE;
		CCOutChar(0,0,0,channel,FALSE);//2
	}
	
	/* calculate the drawing coordinates */
	ccxpos = col*charWidth + CCLEFT + (channel*300);
	ccypos = row*height + CCTOP;
	
	ClientToScreen(gDisplayHwnd,&p1);
	hdc = GetDC(gDisplayHwnd);
	
	if(ch == 0) /* it is the clear signal, cover the whole display */
	{
		height *= (CCDISPLAY_H);
		width *= (CCDISPLAY_W+2);
	}
	else if( /*ch == '\r' ||*/ ch == 0x10) /* clear to the end of the line */
	{
		width = (CCDISPLAY_W-col+1)*charWidth;
		ovlcolor = OVERLAY_KEY;
		bDraw = FALSE;
	}
	else if( ch == '\b' ) /* back space 0x08 */
	{
		ovlcolor = OVERLAY_KEY; 
	}
	
	/* close caption trigger at the beginning of a line */
	if(col==0)
		gOSDenable |= gOSD;	
	
	/* create the drawing rectangle */	
	SetRect(&rc, ccxpos, ccypos, ccxpos+width, ccypos+height);
	if(bDraw && gOSDenable)
	{
	   SelectObject(hdc, GetStockObject(OEM_FIXED_FONT));
	   SetBkColor(hdc,BLACK);
	   SetTextColor(hdc, gCCbg ? ovlcolor:ccTextColor); 		
	   ExtTextOut(hdc, ccxpos, ccypos, ETO_OPAQUE, &rc, (char *)&ch, 1, NULL);
	   ccxpos += charWidth;
	   if(gCCbg) /* this is for transparent background */
	   {
			if(ccBox.top == 0)
			{
				ccBox = rc;
			}
			else
			{
				if(ccBox.top > rc.top)
					ccBox.top = rc.top;
				if(ccBox.left > rc.left)
					ccBox.left = rc.left;
				if(ccBox.bottom < rc.bottom)
					ccBox.bottom = rc.bottom;
				if(ccBox.right < rc.right)
					ccBox.right = rc.right; 
			}

	   }
	}
	if(!bDraw) /* erase, clear to end , clear the screen */
	{
		gOvlBrush = CreateSolidBrush(ovlcolor);
		FillRect(hdc, &rc,gOvlBrush);
		DeleteObject(gOvlBrush);
		ccBox.top = ccBox.left = ccBox.bottom = ccBox.right = 0;
	}
	ReleaseDC(gDisplayHwnd, hdc);
#if 0
	switch(ch) {
	case '\r':
		xpos = STATUSMARGIN_X;
		return;
	case '\n':
		ypos += nCharHeight;
		GetClientRect(hwnd, &rc);
		if(ypos > (ROWS-1)*nCharHeight + STATUSMARGIN_Y) {
			ypos -= nCharHeight;
			/* scroll window using bitblt ;-)*/
		hdc = GetDC(hwnd);
		BitBlt(hdc, STATUSMARGIN_X, STATUSMARGIN_Y, rc.right-STATUSMARGIN_X*2,
			rc.bottom-nCharHeight-STATUSMARGIN_Y*2,
			hdc, STATUSMARGIN_X, nCharHeight+STATUSMARGIN_Y, SRCCOPY);
		rc.top = ypos;
		rc.left += STATUSMARGIN_X;
		rc.right -= STATUSMARGIN_X;
		rc.bottom -= STATUSMARGIN_Y;
		FillRect(hdc, &rc,
		(HBRUSH)GetClassLong(hwnd, GCL_HBRBACKGROUND));
		ReleaseDC(hwnd, hdc);
	      }
		return;
	case '\007':			/* bel*/
		write(STDERR_FILENO, "\007", 1);
		return;
	case '\t':
		xpos += nCharWidth;
		while((xpos/nCharWidth) & 7)
			EmOutChar(hwnd, ' ');
		return;
	case '\b':
		if(xpos <= STATUSMARGIN_X)
			return;
		xpos -= nCharWidth;
		EmOutChar(hwnd, ' ');
		xpos -= nCharWidth;
		return;
	}

	/* draw some text*/
	hdc = GetDC(hwnd);
	SelectObject(hdc, GetStockObject(SYSTEM_FIXED_FONT));
	SetBkColor(hdc,GetSysColor(COLOR_BTNFACE));
	SetTextColor(hdc, gStatusColor);
	SetRect(&rc, xpos, ypos, xpos+nCharWidth, ypos+nCharHeight);
	ExtTextOut(hdc, xpos, ypos, ETO_OPAQUE, &rc, (char *)&ch, 1, NULL);
	ReleaseDC(hwnd, hdc);
	xpos += nCharWidth;
	if(xpos > (COLS-1)*nCharWidth) {
		xpos = STATUSMARGIN_X;
		EmOutChar(hwnd, '\n');
	}
#endif
}

/* preference window handler */

LRESULT CALLBACK
PrefWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) 
{
	BOOL bButtonClick = HIWORD(wp) == BN_CLICKED;
	HWND	itemhwnd;
	switch(msg) 
	{
		case WM_COMMAND:
		if(bButtonClick )
		{
			int id = LOWORD(wp);
			itemhwnd = GetDlgItem(hwnd,id);

			switch(id)
			{
			case IDC_PATTERN: ShowPattern(-2); break;
			case IDC_CLOSECAPTION: ShowCloseCaption(ITEM_APPLY); break;
			case IDC_VOLUMEUP: SetAudio(audioselection,muting=0,1); break;
			case IDC_VOLUMEDOWN: SetAudio(audioselection,muting=0,-1); break;
			case IDC_MUTE: SetAudio(audioselection,
                                SendMessage(itemhwnd,BM_GETCHECK,0,0),0); break;
			case IDC_LOGO: SetLogo(ITEM_APPLY); break;
			case IDC_SCALE: ShowScale(ITEM_APPLY); break;  
			case IDC_DVIP: SetDVIP(ITEM_APPLY); break; 
			case IDC_CINEMA: ShowMenuBar(ITEM_APPLY); break;
			case IDC_STATUSWND: ShowStatus(ITEM_APPLY); 
                                   break; //by check box
			case IDC_CLOSEPREF: ShowPref(-1); break;
			case IDC_EXIT: PostMessage(gHwnd, WM_CLOSE, 0, 0); break;
			default:
				return DefWindowProc( hwnd, msg, wp, lp);
				break;
			} // switch
			SetFocus(gDisplayHwnd);
		}
		break;
		case WM_PAINT:
			//hdc = BeginPaint(hwnd, &ps);
			//GetClientRect(hwnd, &rc);
			//DrawDIB(hdc, rc.left, rc.top, image);
			//EndPaint(hwnd, &ps);
			//break;
		default:
			return DefWindowProc( hwnd, msg, wp, lp);
	}
	return( 0);
}

/* instruct the driver to switch video source by selection,
for mpeg playing, mode is used to select source file */
int SelectVideoSource(int cmdShow, int selection, int mode )
{
	gVidSelection = selection;
	int retval = 0;
	if(vbi >= 0)
	{
		/* stop close caption first */
		ShowCloseCaption(0);
		gOSDcount = 1;
	}
	
	/* set the channel if select tuner */
	if(cmdShow == SW_SHOW)
		SetChNum(gChNum);
	
	/* for other source, clear the channel display */
	else if(cmdShow == SW_HIDE)
		SetChNum(-1);
		
	/* close mpeg playing */
	if((gVidSelection != VID_DIGITAL || gMpegMode!=mode) && mpegPlaying)
	{
		PlayMpeg(MPEG_CLOSE,mode);
		gMpegMode= mode;
	}
	
	/* pass the video screen size to the driver */
	set_video_fmt(gDecoderW,gDecoderH);
        if(capture == 0) {
	  if (capture_enable(1) != -1)
             capture = 1;
        }	
	/* and prepare to show the video */
	set_overlay_info( OVERLAY_KEY, OVERLAY_MASK, 1, 1);
	set_vout_window(gOverlayX,gOverlayY,gOverlayW,gOverlayH);
	set_input(selection);
	if (preview(1) != -1)
            PreviewEnable = 1; // show video
	
	/* for playing mpeg, tell the sigma driver to start up */
	if(gVidSelection == VID_DIGITAL && !mpegPlaying) //digital video
	{
		if(mpegPlaying)
			PlayMpeg(MPEG_CLOSE,gMpegMode);
		if (PlayMpeg(MPEG_START,mode)==-1)
                    retval = -1;
		else if (PlayMpeg(MPEG_UPDATE,mode)==-1)
                    retval = -1;
	} 
	
	/* synchronize audio source */
	SetAudio(selection,muting,0);
	SetFocus(gDisplayHwnd);
        return retval;
}

/* set the mixer to play the audio from a source */
int SetAudio(int selection, int mute, int increment) 
{

static int mixdev[4] = { SOUND_MIXER_VIDEO,SOUND_MIXER_LINE,
                         SOUND_MIXER_LINE, SOUND_MIXER_LINE1};
	
	char tmp[80];
	int mixer,rc,val, valmix;
	HWND itemhwnd;
	
	muting = mute;
	printf("Coming into setaudio of vtest -- Lakshmi \n");	

	sprintf(tmp,"switch from %d to %d ", audioselection,selection);
	StatusOutStr(tmp);
	
	itemhwnd = GetDlgItem(gPrefHwnd,IDC_MUTE);
	if(itemhwnd > 0)
	{
		SendMessage(itemhwnd,BM_SETCHECK,muting ? 1:0,0);
	}

	mixer = open( "/dev/mixer", O_RDONLY );
	if(mixer < 0)
	{
		StatusOutStr("open mixer failed\r\n"); //SOUND_MIXER_INFO
	}
	else
	{
		sprintf(tmp,"mixer = %X ", mixer);
		StatusOutStr(tmp);
		printf("Entering before the if of selection!=audioselection\n");
		printf("audioselection = %d and selection = %d",audioselection,selection);

		//mute the current selection
		if(selection != audioselection)
		{
	printf("Entered into the if of selection!=audioselection \n");
printf("audioselection = %d and selection = %d",audioselection,selection);

			val = 0x0000;
                        valmix = mixdev[audioselection];
			rc = ioctl(mixer, _IOC(_IOC_WRITE|_IOC_READ,'M',
                              valmix,sizeof(int)), &val);
			if(rc < 0)
			{
			sprintf(tmp,"(%d)=_IOC_WRITE|_IOC_READ",valmix); 
				StatusOutStr(tmp);	
			}
			rc = ioctl(mixer, _IOC(_IOC_READ,'M',
                                   valmix,sizeof(int)), &val);
			if(rc < 0)
			{
				sprintf(tmp,"(%d)=_IOC_READ ", valmix);
				StatusOutStr(tmp);	
			}
			sprintf(tmp,"(%d)=%X ", valmix, val);
			StatusOutStr(tmp);
		}

		audioselection = selection;
printf("audioselection = %d and selection = %d",audioselection,selection);
printf("The volumes[audioselection] = %d\n",volumes[audioselection]);
		volume = volumes[audioselection];
		volume += increment;
		if(volume > 99)
			volume = 99;
		else if(volume < 1)
			volume = 1;
		volumes[audioselection] = volume;
printf("The volumes[audioselection] = %d\n",volumes[audioselection]);
printf("mixdev[audioselection] = %d\n",mixdev[audioselection]);
	
		
		val = (muting) ? 0 : ((volume << 8) + volume);
		rc = ioctl(mixer, _IOC(_IOC_WRITE|_IOC_READ,'M',
                          mixdev[audioselection],sizeof(int)), &val);
		if(rc < 0)
		{
			sprintf(tmp,"(%d)=_IOC_WRITE|_IOC_READ ", 
                                mixdev[audioselection]);
			StatusOutStr(tmp);	
		}
		rc = ioctl(mixer, _IOC(_IOC_READ,'M',
                           mixdev[audioselection],sizeof(int)), &val);
		if(rc < 0)
		{
			sprintf(tmp,"(%d)=_IOC_READ ", mixdev[audioselection]);
			StatusOutStr(tmp);	
		}
		sprintf(tmp,"(%d)=%X ", mixdev[audioselection], val);
		StatusOutStr(tmp);
		
		StatusOutStr("\r\n");	
		close(mixer);
	}
	return 0;
	printf("Coming out of setaudio in vtest -- lakshmi \n");
}

/* main window handler */
LRESULT CALLBACK
MainWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	//PAINTSTRUCT	ps;
	//HDC		hdc;
	RECT		rc;


	BOOL bButtonClick = HIWORD(wp) == BN_CLICKED;
	HWND	itemhwnd;
	//int	x,y;
	
	switch( msg) {
	case WM_COMMAND:
		if(bButtonClick )
		{
			int id = LOWORD(wp);
			itemhwnd = GetDlgItem(hwnd,id);

			switch(id)
			{
			case IDC_VIDEO: SelectVideoSource(SW_HIDE,VID_COMPOSITE,0); 
                                        break;
			case IDC_SVIDEO: SelectVideoSource(SW_HIDE,VID_SVIDEO,0); 
                                        break;
			case IDC_DIGITAL: 
                               if(fileIndex !=3 ) {
                                  if ( gMpegMode != MPEG_CLOSE)   
                                     PlayMpeg(MPEG_CLOSE, 0);
                                  fileIndex = 3; 
                               }
                               SelectVideoSource(SW_HIDE,VID_DIGITAL,0); 
                               break;
			case IDC_TUNER: SelectVideoSource(SW_SHOW,VID_TUNER,0); break;
			case IDC_STREAM: 
                               if(fileIndex !=4 ) {
                                 if ( gMpegMode != MPEG_CLOSE)  
                                     PlayMpeg(MPEG_CLOSE, 0);
                                 fileIndex = 4; 
                               }
			       SelectVideoSource(SW_HIDE,VID_DIGITAL,1); 
                               break;
			case IDC_PREF: ShowPref(-1); break; //toggle

			default:
				return DefWindowProc( hwnd, msg, wp, lp); break;
			} // switch
			SetFocus(gDisplayHwnd);
		}
		else
		{
			return DefWindowProc( hwnd, msg, wp, lp);
		}
		break;	

	case WM_TIMER:
		/* use window timer to do piriodic tasks */
		if(wp == mainTimerID )
		{
			if(mpegPlaying)
			{
				/* update the mpeg buffer */
				PlayMpeg(MPEG_UPDATE,0);
			}
			else if(gOSD)
			{
				/* respond to vbi incoming data */
				CheckCC();
			}	
			if(--mainTimer == 0) /* longer period */
			{
				mainTimer = 50;
				/* channel number timeout, restore */
				if(channelCounter)
				{
					if(--channelCounter == 0)
						SetChNum(gChNum);
				
				}
				/* the logo heartbeat */
				if(gLogo && --logoCounter == 0)
				{
				  ++gLogo;
				  if(gLogo & 1) //opaque to transparent
				    SetAlphaBlend(alpha0,gAlphaRect,0,0x00FFFF,0,0); 
				  else //transparent to opaque				
				    SetAlphaBlend(alpha0,gAlphaRect,0,0x000100,0,0); 
				  logoCounter = 6;
				
				}
				/* re-enable close caption */
				if(gOSDcount && --gOSDcount == 0)
					ShowCloseCaption(ITEM_ON);
			}
		
		}
		break;

	case WM_CLOSE:
		/* clean up before exiting */
		KillTimer(gHwnd, mainTimerID);
		if(mpegPlaying)
			PlayMpeg(MPEG_CLOSE,0);
		
		/* remove all alpha windows */
		SetRect(&rc,0,0,0,0);
		gOverlayW = resolutionX;
		gOverlayH = resolutionY;
		gOverlayX = gOverlayY = 0;
		
		/* stop close captioning */
		if(vbi >= 0)
		   ShowCloseCaption(ITEM_OFF);
		
		/* mute the audio */
		SetAudio(audioselection,1,0);
		
		/* turn  off the video stream */
                if (PreviewEnable)
		   preview(0);
		close_devices();
		//VMW_AVS_VideoClose();
			
		/* that's it */
		PostQuitMessage(0);
		break;
		
	case WM_SIZE:
		break;

	case WM_MOVE:
		break;
		
	case WM_LBUTTONDOWN:
		break;

	case WM_MOUSEMOVE:
		break;

	case WM_LBUTTONUP:
		break;

	case WM_RBUTTONDOWN:
		break;

	default:
		return DefWindowProc( hwnd, msg, wp, lp);
	}
	return( 0);
}

/*char buff[20];
void callback(int a, void * data)
{
	printf("Hello\n");
}
*/


/* application entry point from microwindows */
int WINAPI 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine,
	int nShowCmd)
{
	MSG 	msg;
	HWND	hwnd;
	RECT	rc;
	int audio;
	int width,height;
	
	RegisterAppClass();
	GetWindowRect(GetDesktopWindow(), &rc);
	
	/* open vout will initialize the driver */
	if (open_devices()==-1) {
          PostMessage(gHwnd, WM_CLOSE, 0, 0);
          return 0;
        }
	if (get_vout_format(&width,&height)==-1)
          gQuit = 1;
	printf("Width :%d, Height :%d\n",width,height);
	if (set_video_fmt(width,height)== -1)
          gQuit = -1;
        if(capture == 0) {
	  if (capture_enable(1) == -1)
             gQuit = 1;
          else
              capture = 1;
        }
	if (set_overlay_info( OVERLAY_KEY, OVERLAY_MASK, 1, 1) == -1)
           gQuit = 1;
	if (set_alpha_blend_info(0,0, 0, width,height, 1,100,0,1,0xFFFF0000)==-1)
           gQuit = 1;
	if (set_vout_window(0,0,width,height)==-1)
           gQuit = 1;
#ifndef GEODE_V4L2_105
	if (set_vout_control(1 /*VL_VIDEO_OVERLAY_COLOR_KEY*/)==-1)
          gQuit = 1;
#endif	
	/* CreateAppWindow will also set up the alpha windows for the menu */ 
	hwnd = CreateAppWindow(); 
	
	/* force the audio driver to load */
	audio = open( "/dev/audio", O_RDONLY );
        if (audio == -1) gQuit = 1;
	close(audio);

	/* set default tuner channel */
//	SetChannel(gChNum);
        if(gQuit == 0) {
	   if (SelectVideoSource(gVidSelection==VID_TUNER ? SW_SHOW:SW_HIDE, 
                          gVidSelection,0) == -1)
            gQuit = 1;
	}
	/* run the background timer task */
	SetTimer(gHwnd, mainTimerID, 20, NULL); //WM_TIMER 20
	
	//work around -- to fix the flicker by launching a second time
	if(gQuit)
		PostMessage(gHwnd, WM_CLOSE, 0, 0);
		
	/* put the arrow cursor to the edges */
	GdMoveCursor(resolutionX,resolutionY);
	
	/* set default sharpness */	
	ChangeShapness(0);
	
	/* running the event  loop */	
	while(GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return 0;
}

//------------------------------------------------
/* display the text string in the status window */
void
StatusOutStr(LPCSTR str)
{
	char c;
	gStatusColor = RED;
	while(0 != (c = *str++))
	{
		EmOutChar(gStatusHwnd,c);	
	}
	gStatusColor = CYAN;
}

/* display a character in the status window */
void
EmOutChar(HWND hwnd, int ch)
{
	HDC	hdc;
	RECT	rc;

	switch(ch) {
	case '\r':
		xpos = STATUSMARGIN_X;
		return;
	case '\n':
		ypos += nCharHeight;
		GetClientRect(hwnd, &rc);
		if(ypos > (ROWS-1)*nCharHeight + STATUSMARGIN_Y) {
			ypos -= nCharHeight;

			/* scroll window using bitblt ;-)*/
			hdc = GetDC(hwnd);
			BitBlt(hdc, STATUSMARGIN_X, STATUSMARGIN_Y, 
                            rc.right-STATUSMARGIN_X*2,
			    rc.bottom-nCharHeight-STATUSMARGIN_Y*2,
			    hdc, STATUSMARGIN_X, nCharHeight+STATUSMARGIN_Y, SRCCOPY);
			rc.top = ypos;
			rc.left += STATUSMARGIN_X;
			rc.right -= STATUSMARGIN_X;
			rc.bottom -= STATUSMARGIN_Y;
			FillRect(hdc, &rc,
				(HBRUSH)GetClassLong(hwnd, GCL_HBRBACKGROUND));
			ReleaseDC(hwnd, hdc);
		}
		return;
	case '\007':			/* bel*/
		write(STDERR_FILENO, "\007", 1);
		return;
	case '\t':
		xpos += nCharWidth;
		while((xpos/nCharWidth) & 7)
			EmOutChar(hwnd, ' ');
		return;
	case '\b':
		if(xpos <= STATUSMARGIN_X)
			return;
		xpos -= nCharWidth;
		EmOutChar(hwnd, ' ');
		xpos -= nCharWidth;
		return;
	}

	/* draw some text*/
	hdc = GetDC(hwnd);
	SelectObject(hdc, GetStockObject(SYSTEM_FIXED_FONT));
	SetBkColor(hdc,GetSysColor(COLOR_BTNFACE));
	SetTextColor(hdc, gStatusColor);
	SetRect(&rc, xpos, ypos, xpos+nCharWidth, ypos+nCharHeight);
	ExtTextOut(hdc, xpos, ypos, ETO_OPAQUE, &rc, (char *)&ch, 1, NULL);
	ReleaseDC(hwnd, hdc);
	xpos += nCharWidth;
	if(xpos > (COLS-1)*nCharWidth) {
		xpos = STATUSMARGIN_X;
		EmOutChar(hwnd, '\n'); 
	}
}

/*#if ELKS
#define SHELL	"/bin/sash"
#else
#if DOS_DJGPP
#define SHELL	"bash"
#else
#define SHELL	"/bin/sh"
#endif
#endif*/
#define SHELL	"/bin/sh"
static int pid;

static void
ptysignaled(int signo)
{
	switch(signo) {
	case SIGINT:	/* interrupt*/
//#if !ELKS
		/* this doesn't work, can anyone fix it?*/
		killpg(pid, SIGINT);
//#endif
		return;
	case SIGCHLD:	/* child status change - child exit*/
		DestroyWindow(GetActiveWindow());
		CreateAppWindow();
		return;
	}
	fprintf(stderr, "Uncaught signal %d\n", signo);
}

/*
 * Create a shell running through a pseudo tty, return the shell fd.
 */
int
CreatePtyShell(void)
{
	int	n = 0;
	int	tfd;
	char	pty_name[12];
	char *	argv[2];

again:
	sprintf(pty_name, "/dev/ptyp%d", n);
	if ((tfd = open(pty_name, O_RDWR | O_NONBLOCK)) < 0) {
		if ((errno == EBUSY || errno == EIO) && n < 10) {
			++n;
			goto again;
		}
	        fprintf(stderr, "Can't create pty %s\n", pty_name);
		return -1;
	}
	signal(SIGCHLD, ptysignaled);
	signal(SIGINT, ptysignaled);
	if ((pid = fork()) == -1) {
		fprintf(stderr, "No processes\n");
		return -1;
	}
	if (!pid) {
		close(STDIN_FILENO);
		close(STDOUT_FILENO);
		close(STDERR_FILENO);
		close(tfd);
		
		setsid();
		pty_name[5] = 't';
		if ((tfd = open(pty_name, O_RDWR)) < 0) {
		   fprintf(stderr, "Child: Can't open pty %s\n", pty_name);
		   exit(1);
		}
		dup2(tfd, STDIN_FILENO);
		dup2(tfd, STDOUT_FILENO);
		dup2(tfd, STDERR_FILENO);
		/*if(!(argv[0] = getenv("SHELL")))*/
			argv[0] = SHELL;
		argv[1] = NULL;
		execv(argv[0], argv);
		exit(1);
	}
	return tfd;
}

int
ReadPtyShell(int fd, char *buf, int count)
{
	return read(fd, buf, count);
}

int
WritePtyShell(int fd, char *buf, int count)
{
	return write(fd, buf, count);
}

void
ClosePtyShell(int fd)
{
	if(ttyfd != -1)
		close(fd);
}


#ifdef DEBUG_CC
FILE*	fcc = 0;
int curCCrow = 0;
#endif

#define CCSIZE	256
#define CCSIZEMASK (CCSIZE-1)
char ccbuf[256];
int ccin = 0;
int ccout = 0;

unsigned char parity[256] = {
1,0,0,1,0,1,1,0,0,1,1,0,1,0,0,1,
0,1,1,0,1,0,0,1,1,0,0,1,0,1,1,0,
0,1,1,0,1,0,0,1,1,0,0,1,0,1,1,0,
1,0,0,1,0,1,1,0,0,1,1,0,1,0,0,1,

0,1,1,0,1,0,0,1,1,0,0,1,0,1,1,0,
1,0,0,1,0,1,1,0,0,1,1,0,1,0,0,1,
1,0,0,1,0,1,1,0,0,1,1,0,1,0,0,1,
0,1,1,0,1,0,0,1,1,0,0,1,0,1,1,0,

0,1,1,0,1,0,0,1,1,0,0,1,0,1,1,0,
1,0,0,1,0,1,1,0,0,1,1,0,1,0,0,1,
1,0,0,1,0,1,1,0,0,1,1,0,1,0,0,1,
0,1,1,0,1,0,0,1,1,0,0,1,0,1,1,0,

1,0,0,1,0,1,1,0,0,1,1,0,1,0,0,1,
0,1,1,0,1,0,0,1,1,0,0,1,0,1,1,0,
0,1,1,0,1,0,0,1,1,0,0,1,0,1,1,0,
1,0,0,1,0,1,1,0,0,1,1,0,1,0,0,1 };

/* close caption pac translation */
unsigned char pac[0x10] = {
/*0x10*/ 11,0,
/*0x11*/ 1,2,
/*0x12*/ 3,4,
/*0x13*/ 12,13,
/*0x14*/ 14,15,
/*0x15*/ 5,6,
/*0x16*/ 7,8, 
/*0x17*/ 9,10 };

/* this function takes 2 bytes from the vbi stream 
decodes the bytes into text,special characters and command
*/
int parse_cc( unsigned char cc1, unsigned char cc2, int init )
{  
/* there could be up to 2 channel/stream of data in close captioning */
	static int channel = 0;
	
	/* the display attributes of each channel are kept static here */
	static int color[2] = {0,0};
	static int underline[2] = {0,0};
	static int mode[2] = {0,0}; //none=0,popup=1, roll=2,3,4, paint=5
	static int rown[2] = {0,0};
	static int coln[2] = {0,0};
	
	/* for commands, the pair are sent twice */
	static char ctrl1,ctrl2;	
	//static int modesave[2] = {0,0};
	unsigned char c1,c2,subc2,subc1;
	char tmp[CCDISPLAY_H*CCDISPLAY_W];
	int ctrl = 0;
	
/* the init action needs to be done when switching channel or 
receiving high rate of errors */
	if(init)
	{
		memset(mem_display, 0, sizeof(mem_display));
		memset(mem_nondisplay, 0, sizeof(mem_nondisplay));
		channel = -1; //no channel
		mode[0] = mode[1] = 0; //none
		underline[0] = underline[1] = 0;
		//rown coln
		rown[0]=rown[1]=14;
		coln[0]=coln[1]=0;
		ctrl1 = ctrl2 = 0;
		//clear display
		CCOutChar(0,0,0,0,FALSE); //3 erase the screen
		CCOutChar(0,0,0,1,FALSE); //3 erase the screen
		gVbiSignal = 0;
		return 0;
	}
	
	/* strip off the high bits */
	cc1 &= 0x7F;
	cc2 &= 0x7F;
	c1 = cc1;
	c2 = cc2;
	
	/* is this the repeated pair */
	if(cc1 == ctrl1 && cc2 == ctrl2)
	{
		ctrl = 1;
		EmOutChar(gStatusHwnd,'*');	
		EmOutChar(gStatusHwnd,channel+0x30);	
		EmOutChar(gStatusHwnd,mode[channel]+0x30);	
	}
	
	ctrl1 = cc1;
	ctrl2 = cc2;
	
	/* starts looking at the value of the bytes */
	if(cc1 < 0x10)
	{
		cc1 = 0; // treat cc2 as normal	
	}
	else
	if(cc1 < 0x20)
	{
		/* detecting the PAC code */
		if(cc2 & 0x40)
		{						
			subc2 = c2 & 0x0F;
			c2 &= 0xF0;
			
			subc1 = (c1 & 7) << 1;			
			if(c2 & 0x20) ++subc1;
			
			/* is it a legal PAC */
			if(pac[subc1])
			{
				/* extract the channel indicator */
				channel = (c1 & 8) ?  1:0;
				
				/* extract the row number */
				rown[channel] = pac[subc1] - 1;
				coln[channel] = 0;
				
				/* there could be indentation or color */
				if(cc2 & 0x10) //indent
					coln[channel] = (cc2 & 0x0E) << 1;

				else
					color[channel] = (cc2 & 0x0E) >> 1;
					
				/* and underline as well */
				underline[channel] = cc2 & 1;
				sprintf(tmp,"<pac%d %d %d>",channel,
                                        rown[channel],coln[channel]);
				StatusOutStr(tmp);
					
			}
			return 0; //no further processing
		}
		else
		switch(cc1)
		{
		case 0x11:
		case 0x19:
			if(cc2 < 0x20)
			{
				return 0;
			}
			else
			{ 
				channel = (c1 & 8) ? 1:0;
				if(cc2 < 0x30)
				{					 
				  color[channel] = (cc2 & 0x0E) >> 1;
				  underline[channel] = cc2 & 1;
				  return 0;
					 
				/*case 0x20: //cc1 = 0; cc2 = 0; break; //white
				case 0x21: //cc1 = 0; cc2 = 0; break; //white, underline
				case 0x22: //cc1 = 0; cc2 = 0; break; //green
				case 0x23: //cc1 = 0; cc2 = 0; break; //green, underline
				case 0x24: //cc1 = 0; cc2 = 0; break; //blue
				case 0x25: //cc1 = 0; cc2 = 0; break; //blue, underline
				case 0x26:// cc1 = 0; cc2 = 0; break; //cyan
				case 0x27: //cc1 = 0; cc2 = 0; break; //cyan, underline
				case 0x28: //cc1 = 0; cc2 = 0; break; //red
				case 0x29: //cc1 = 0; cc2 = 0; break; //red, underline
				case 0x2A: //cc1 = 0; cc2 = 0; break; //yellow
				case 0x2B: //cc1 = 0; cc2 = 0; break; //yellow, underline
				case 0x2C: //cc1 = 0; cc2 = 0; break; //magenta
				case 0x2D: //cc1 = 0; cc2 = 0; break; //magenta, underline
				case 0x2E: //cc1 = 0; cc2 = 0; break; //italics
				case 0x2F: //cc1 = 0; cc2 = 0; break; //italics, 
                                underline*/
				}
				else
				{	
				/* for special characters */
				switch(cc2)
				{
				case 0x30: cc1 = 0; cc2 = '@'; break; //register mark
				case 0x31: cc1 = 0; cc2 = '@'; break; //degree
				case 0x32: cc1 = 0; cc2 = '@'; break; //1/2
				case 0x33: cc1 = 0; cc2 = '@'; break; //inverse query
				case 0x34: cc1 = 0; cc2 = '@'; break; //trade mark
				case 0x35: cc1 = 0; cc2 = 'c'; break; //cent
				case 0x36: cc1 = 0; cc2 = '#'; break; //sterling pound
				case 0x37: cc1 = 0; cc2 = '@'; break; //music note
				case 0x38: cc1 = 0; cc2 = 'a'; break; //a+
				case 0x39: cc1 = 0; cc2 = '_'; break; //transparent space
				case 0x3A: cc1 = 0; cc2 = 'e'; break; //e
				case 0x3B: cc1 = 0; cc2 = 'a'; break; //a
				case 0x3C: cc1 = 0; cc2 = 'e'; break; //e
				case 0x3D: cc1 = 0; cc2 = 'i'; break; //i
				case 0x3E: cc1 = 0; cc2 = 'o'; break; //o
				case 0x3F: cc1 = 0; cc2 = 'u'; break; //u
				}
				cc1 = 0;
				}		
			}
			break;
		case 0x14:
		case 0x1C:
			if(ctrl) 
				return 0; //reject the second pair of Control Code
			
			/* apply to channel */
			channel = (c1 & 8) ? 1:0;
	 
			switch(cc2)
			{
			case 0x20: /* /RCL resume caption loading */
				StatusOutStr("\r\n<RCL>----------------pop"); 
				mode[channel] = CC_POP;
				
				return 0;
				 
			case 0x21: /* BS back space  */
				if(coln[channel]) 
				{
				  --coln[channel]; 
				  CCOutChar('\b',rown[channel],coln[channel],
                                      channel,FALSE);
				}
				StatusOutStr("<BS>");
				return 0; 
				
			case 0x22: return 0; //reserved
			case 0x23: return 0; //reserved
			
			case 0x24: /* DER delete to end of row */
				DeleteToEnd(rown[channel],coln[channel],
                                            mode[channel],channel);
				StatusOutStr("<DER>");
				return 0;
				
			case 0x25: //RU2 rollup 2
			  if(mode[channel] < CC_RU2) //switch from other modes
			  {
			    rown[channel]=14; //reset base row
			    memset(mem_display[channel],0,CCDISPLAY_H*CCDISPLAY_W);
			    memset(mem_nondisplay[channel],0,CCDISPLAY_H*CCDISPLAY_W);
			  }
			  SetRollup(2,mode[channel],rown[channel],channel);
			  mode[channel] = CC_RU2;
			  coln[channel] = 0;
			  StatusOutStr("\r\n<RU2>-----------------"); 
			  return 0;
				
			case 0x26: //RU3 rollup 3
			 if(mode[channel] < CC_RU2) //switch from other modes
			 {
			  rown[channel]=14; //reset base row
			  memset(mem_display[channel],0,CCDISPLAY_H*CCDISPLAY_W);
			  memset(mem_nondisplay[channel],0,CCDISPLAY_H*CCDISPLAY_W);
			 }
			 SetRollup(3,mode[channel],rown[channel],channel);
			 coln[channel ]= 0;
			 mode[channel] = CC_RU3;
			 StatusOutStr("\r\n<RU3>-----------------"); 
			 return 0;
			case 0x27: //RU4 rollup 4
			 if(mode[channel] < CC_RU2) //switch from other modes
			 {
			  rown[channel]=14; //reset base row
			  memset(mem_display[channel],0,CCDISPLAY_H*CCDISPLAY_W);
			  memset(mem_nondisplay[channel],0,CCDISPLAY_H*CCDISPLAY_W);
			 }
			 SetRollup(4,mode[channel],rown[channel],channel);
			 coln[channel] = 0;
			 mode[channel] = CC_RU4;
			 StatusOutStr("\r\n<RU4>-----------------"); 
			 return 0;
			case 0x28: return 0; //Flash on
			case 0x29: //Resume direct captioning
			        StatusOutStr("\r\n<RDC>----------------paint"); 
				mode[channel] = CC_PAINT;
				return 0; 
			case 0x2A:
				StatusOutStr("\r\n<text restart>");
				//modesave[channel] = mode[channel]; 
				return 0; //text restart
			case 0x2B:
				StatusOutStr("\r\n<text resume>"); 
				return 0; //Resume text display
			
			case 0x2C:  //erase display memory, erase screen
				memset(mem_display[channel],0,
                                      sizeof(mem_display[channel]));
				CCOutChar(0,0,0,channel,FALSE);
				StatusOutStr("<Erase display>");
				return 0;
			case 0x2D: //cr
			//CCOutChar('\r',rown[channel],coln[channel],channel,FALSE);
				StatusOutStr("<CR>");
				if(mode[channel] >= CC_RU2)
				{
				  CCRollup(mode[channel], rown[channel], channel);
				  coln[channel] = 1;
				}
				
				return 0;
			case 0x2E: //erase non-display memory
				memset(mem_nondisplay[channel],0,
                                       sizeof(mem_nondisplay[channel]));
				StatusOutStr("<Erase buffer>");
				return 0;
			case 0x2F: //end of caption, flip memory
				memcpy(tmp,mem_display[channel],sizeof(tmp));
				memcpy(mem_display[channel],mem_nondisplay[channel],
                                       sizeof(mem_display[channel]));
				memcpy(mem_nondisplay[channel],tmp,
                                       sizeof(mem_nondisplay[channel]));
				StatusOutStr("<End of caption>");
				UpdateDisplayFromMem(channel);
				//CCInsert(1,0,0,CC_POP,channel);
				mode[channel] = CC_POP;
				return 1;
			}			
			break;
		case 0x17:
		case 0x1F:
			channel = (c1 & 8) ? 1:0;		 
			switch(cc2)
			{
			case 0x21: //T1 Tab offset 1
				coln[channel] += 1;
				if(coln[channel] > 31)
					coln[channel] = 31;
				StatusOutStr("<Tab1>");	
				break;
			case 0x22: //T2 Tab offset 2
				coln[channel] += 2;
				coln[channel] &= ~2;
				if(coln[channel] > 31)
					coln[channel] = 31;
				StatusOutStr("<Tab2>");	
				break;
			case 0x23: //T3 Tab offset 3
				coln[channel] += 3;
				coln[channel] -= coln[channel] % 3;
				if(coln[channel] > 31)
					coln[channel] = 31;
				StatusOutStr("<Tab3>");	
				break;
			}			
			return 0;
		default:
			return 0;
		}
	}
	
	/* for regular text character */
	if(channel >= 0)
	{
	
		if( cc1 )
		{
			if( coln[channel] > 31) 
			{ 
				CCRollup(15, 14, channel);
				coln[channel] = 0;//31;
			}
			coln[channel] += CCInsert(cc1,rown[channel],coln[channel],
                                       mode[channel],channel);
		}
		if( cc2 )
		{
			if( coln[channel] > 31) 
			{ 
				CCRollup(15, 14, channel);
				coln[channel] = 0;//31;
			}
			coln[channel] += CCInsert(cc2,rown[channel],coln[channel],
                                       mode[channel],channel);
		}		
	}
	return 0;
}

/* stop close captioning */
void stopvbi()
{
	int streamon_val = 0;
	//int i;
	//char	vbi_data[2];
#ifdef USEMIDDLEWARE
	VIDEO_FORMAT	fmt;
#else	
	//struct v4l2_format	fmt;
#endif	
	if(vbi >= 0)
	{
	
		/* tell the driver to stop servicing vbi */
		if( ioctl( vbi, VIDIOC_STREAMOFF, &streamon_val ) < 0 )
		{
			StatusOutStr("failed to stream off\r\n");
		}
		
		/* try to empty the driver buffer, may be not necessary */
		//for(i = 0; i < 100; i++)
		//	read( vbi, vbi_data, 2 );
		
		close(vbi);
		vbi = -1;
		
		/* reset the close caption state */
		parse_cc(0,0,1);
		
		/* clear the trigger ready flag */  
		gOSDenable = 0; 
		ccin = ccout = 0;
	}
}


void signal_handler(int sig)
{
	++gVbiSignal;
	return;
}

/* called by the timer service routine, this function frequently unload the vbi data
from the driver buffer, filter the non-sense and store the data in a circular buffer */
int CheckCC()
{
	static int perror = 0;
#ifdef USEMIDDLEWARE
	VIDEO_FORMAT	fmt;
#else	
	struct v4l2_format	fmt;
#endif	
	struct	signal_info_t	sig_info;
	int streamon_val = 0;
	int size,n;
	int ccindex;
	unsigned char vbi_data[12];
	//unsigned char* p;
	//char tmp[80];
	unsigned char c1,c2;
	int	ioctlret = 0;
	int	vbipitch = 2;
	int	vbioffset = 0;
	int	vbiindex;
	/* open the driver if has not done so */
	if(vbi < 0)
	{
		vbi = open( "/dev/vbi", O_RDONLY );
		if(vbi < 0)
		{
			StatusOutStr("vbi open error\r\n");	
		}
		else
		{

			/* set the vbi required data format */
			fmt.fmt.vbi.sampling_rate = 60;
			fmt.fmt.vbi.offset = 9;             
			fmt.fmt.vbi.samples_per_line = 2;
			fmt.fmt.vbi.sample_format =  GEODE_V4L2_VBI_SF_CC_US;
			//fmt.fmt.vbi.sample_format =  V4L2_VBI_SF_UBYTE;
			fmt.fmt.vbi.start[0] = 21;
			fmt.fmt.vbi.start[1] = 284;
			fmt.fmt.vbi.count[0] = 1;
			fmt.fmt.vbi.count[1] = 1;
			fmt.fmt.vbi.flags = 0;
			
			if(vbi107)
				ioctlret = ioctl(vbi,VIDIOC_S_FMT,&fmt);
				
			if( ioctlret < 0 )
			{
				stopvbi();
				StatusOutStr("vbi error\r\n");				
			}
			else
			{
				StatusOutStr("Start close caption\r\n");
#ifdef DEBUG_CC
				fcc = fopen( "cc.txt", "w+" );
#endif				
				/* turn on the vbi data stream */
				if( ioctl( vbi, VIDIOC_STREAMON, &streamon_val ) < 0 )
				{
					StatusOutStr("failed to stream on\r\n");
				}
				
				//if( vbi107 )
				{
				  sig_info.signal_number = SIGUSR1;
				  sig_info.signal_on_length = 2;
				  signal(SIGUSR1,signal_handler);
				// uncomment if you want the driver to signal this app 
				  if( ioctl( vbi, GEODE_IOCTL_S_SIGNAL, &sig_info ) < 0 )
				  {
					StatusOutStr("failed to set signal\r\n");
					gVbiSignal = 1;
					vbi107 = 0;
					vbipitch = 2;
					vbioffset = 0;
				  }
				  else
				  {
					gVbiSignal = 0;
					vbi107 = 1;
					vbipitch = 4;
					vbioffset = 2;
				  }
				 }
				//else
				//	gVbiSignal = 1;
			}
		}

	}

	if(vbi >= 0)
	{
		/* transfer all available vbi data to the circular buffer */
		for( n=0; n<4 && gVbiSignal > 0; n++ )
		{
			if(vbi107)
			{
				--gVbiSignal;
			}
			memset(vbi_data,0,sizeof(vbi_data));
			size = read( vbi, vbi_data, 4 );
			if(vbi107)
			{
				//size -= 2;
			}
			
			for(vbiindex = vbioffset; vbiindex<size; vbiindex += vbipitch)
			{
				
				c1 = vbi_data[vbiindex];
				c2 = vbi_data[vbiindex+1];
				/*if(size != 4)
				{
					sprintf(tmp," %d.%2.2X%2.2X", size,c1, c2);
					StatusOutStr(tmp);
				}
				else
				{
					sprintf(tmp,"%c%c.", c1&127, c2&127);
					StatusOutStr(tmp);
				}
				c1 = vbi_data[2];
				c2 = vbi_data[2+1];*/
				
				/* reject the erronous data */
				if(parity[c1]) 
				{ 
				//sprintf(tmp,"%c%c[ %2.2X%2.2X]", c1, c2,c1, c2);
				//StatusOutStr(tmp);
				//c1 = 0;
					++perror;
				}
				else	--perror;
				
				if(parity[c2]) 
				{
				 // sprintf(tmp,"%c%c[%2.2X%2.2X ]", c1, c2,c1, c2);
				 // StatusOutStr(tmp);
				//c2 = 0;
					++perror;
				}
				else	--perror;
				
				if(perror > 16)
					perror = 16;
				else if(perror < -16)
					perror = -16;
				
				/* reject the non-sense */
				if(perror > 0)
				{
				}
				else
				if(c1 == 0 && c2 == 0)
				{
					//break;
				}
				else
				if(c1 == 0x80 && c2 == 0x80)
				{
					//break;
				}
				else
				if(c1 == 0xA0 && c2 == 0xA0)
				{
					//break;
				}
				else
				{
				/* add the bytes to the circular buffer */
					ccindex = ccin;
					ccindex += 2;
					ccindex &= CCSIZEMASK;
					if(ccindex != ccout)
					{
						ccbuf[ccin++] = c1;
						ccbuf[ccin++] = c2;
						ccin &= CCSIZEMASK;
					}
					else break;
			
				}
				
			}
		}
		
		/* decode 1 pair of close caption bytes at a time */
		return decode_cc();
	}

	return 0;
}


/* read the circular buffer, and parse the close caption data */ 
int decode_cc() 
{
	int rc = 0;
	char c1,c2;
	if(ccin != ccout)
	{
		c1 = ccbuf[ccout++];	
		c2 = ccbuf[ccout++];	
		ccout &= CCSIZEMASK;
		if( parse_cc(c1, c2, 0 ) )
		{
		}
		rc = 1;
				
	}
	return rc;
}


/* show/hide the status window */
void ShowStatus(int show)
{
	HWND itemhwnd = GetDlgItem(gPrefHwnd,IDC_STATUSWND);
	int state = SendMessage(itemhwnd,BM_GETCHECK,0,0);
	if(show >= 0)
		state = show;
	else if(show == -1) //toggle
		state = state ? 0:1;
	ShowWindow(gStatusHwnd,state ? SW_SHOW:SW_HIDE  );
	SendMessage(itemhwnd,BM_SETCHECK,state,0);
}

/* show/hide the preference window */
void ShowPref(int show)
{
	if(show < 0)
		gShowPref = !gShowPref;
	else
		gShowPref = show;
	ShowWindow(gPrefHwnd,gShowPref ? SW_SHOW:SW_HIDE  );
	if(gShowPref)
		ShowStatus(ITEM_APPLY); 
	else
		ShowStatus(ITEM_OFF);
}

/* show/hide the log */
int SetLogo(int show)
{
	//HDC	hdc;
	HWND itemhwnd = GetDlgItem(gPrefHwnd,IDC_LOGO);
	int state = SendMessage(itemhwnd,BM_GETCHECK,0,0);
	if(show >= 0)
		state = show;
	else if(show == -1) //toggle
		state = state ? 0:1;
	if(gScaleVideo)
		state = 0;

	//hdc = GetDC(gDisplayHwnd);
	GetClientRect(gDisplayHwnd, &gLogoRect);
	gLogoRect.left += 14+LOGOX;
	gLogoRect.top += 14+LOGOY;
	gLogoRect.right = gLogoRect.left + 239;
	gLogoRect.bottom = gLogoRect.top + 70;
	
	/* for drawing of the logo */
	InvalidateRect(gDisplayHwnd,&gLogoRect,FALSE);
	gLogo = state;
	if(state)
	{
		logoCounter = 6;
	}
	SendMessage(itemhwnd,BM_SETCHECK,gLogo,0);
	//ReleaseDC(gDisplayHwnd, hdc);
	return 0;
}

/* turn on/off close captioning display */
int ShowCloseCaption(int show)
{
	HWND itemhwnd = GetDlgItem(gPrefHwnd,IDC_CLOSECAPTION);
	int state = SendMessage(itemhwnd,BM_GETCHECK,0,0);
        int i;
        if(gPattern)
            return 0;
	if(show >= 0)
		state = show;
	else if(show == -1) //toggle
		state = state ? 0:1;
	if(gScaleVideo)
		state = 0;
	
	gOSD = state;
	ccCharWidth = ccCharWidth2;
	if(state)
	{
		//SetLogo(0);
		parse_cc(0,0,1); //reset cmd
	}
	else
	{
		if(vbi)
			stopvbi();
           for (i=0; i<ROWS; i++)
	     StatusOutStr(" \r\n"); 
             
	}
	gOSDcount = 0;
	CCOutChar(0,0,0,0,FALSE); //erase channel 1 screen
	CCOutChar(0,0,0,1,FALSE); //erase channel 2 screen

	SendMessage(itemhwnd,BM_SETCHECK,state,0);
	
	return 0;
}

/* enable/disable scaling mode */
int ShowScale(int scale)
{

	//int x,y,w,h;
	HWND itemhwnd = GetDlgItem(gPrefHwnd,IDC_SCALE);
	int state = SendMessage(itemhwnd,BM_GETCHECK,0,0);

	if(scale >= 0)
		state = scale;
	else if(scale == -1) //toggle
		state = state ? 0:1;

	gScaleVideo = state;	
	if(state) //ScaleToWindow
	{
		#define scaleX 96
		#define scaleY 70
		SetLogo(0);
		ShowCloseCaption(0);
		//MoveWindow(gHwnd,0,0,360,240,TRUE);
		MoveWindow(gDisplayHwnd,scaleX,scaleY,
                         resolutionX/2,resolutionY/2,TRUE);
		MoveWindow(gPrefHwnd,PANELX,310,PANELW,PANELH,TRUE);
		MoveWindow(gStatusHwnd,PANELX,STATUSY-PANELY+310,
                         PANELW,PANELH,TRUE);
		gOverlayW = gDecoderW = resolutionX/2;
		gOverlayH = gDecoderH = resolutionY/2;
		gDecoderX = gOverlayX = scaleX;
		gDecoderY = gOverlayY = scaleY;
		SelectVideoSource(-2,gVidSelection,gMpegMode);
		ShowMenuBar(0);
	}
	else 
	{
		gOverlayW = gDecoderW = resolutionX;
		gOverlayH = gDecoderH = resolutionY;
		gOverlayX = gOverlayY = gDecoderX = gDecoderY = 0;
		SelectVideoSource(-2,gVidSelection,gMpegMode);
		//set_video_fmt(gDecoderW,gDecoderH);
		//SetOverLay(gOverlayX,gOverlayY,gOverlayW,gOverlayH);
		
		//cover the whole screen with the color key, 
                //so the alph2 can be deployed somewhere else
		//MoveWindow(gHwnd,r.left,r.top,r.right-r.left,r.bottom-r.top,TRUE);
		MoveWindow(gDisplayHwnd,0,0,resolutionX,resolutionY,TRUE);
		MoveWindow(gPrefHwnd,PANELX,PANELY,PANELW,PANELH,TRUE);
		MoveWindow(gStatusHwnd,PANELX,STATUSY,PANELW,PANELH,TRUE); 
		ShowMenuBar(1);
	}

	SendMessage(itemhwnd,BM_SETCHECK,state,0);
	SetFocus(gDisplayHwnd);
	
	return 0;	
}

#define BUFFERCOUNT 32
int InitMPEGPlay(int StreamType)
{
   int retval = FMPE_OK;
   if (MPEGDriverEntry(NO_DRIVE)!= FMPE_OK){
       printf("MPEG driver entry error, failed to load module/create driver\n");
       retval = -1;
   } else if (FMPOpen(StreamType,64*1024,BUFFERCOUNT,NULL,0)!= FMPE_OK){
       printf("Cannot open the MPEG driver\n");
	 retval = -1;
   } else if ( FMPSet(FMPI_MUTE, 0)!= FMPE_OK){
       printf("FMPSet error\n");
       retval = -1;
   } else if (FMPPlay()!= FMPE_OK){
       printf("Cannot play, the driver is not open\n");
       retval = -1;
   }
   return retval;
}

/* start, stop, pause, replay and update mpeg playing */
int PlayMpeg(int cmd, int mode)
{
	static int maxlog = 0;
	static int readcount = 0;
	char tmp[80];
	static int fd = -1;
	int streamtype;
	int bytesread=1, retval = FMPE_OK;
	int rdcount;

	switch(cmd)
	{
	case MPEG_CLOSE:
        case MPEG_STOP: 
		retval=FMPE_OK;
		if (FMPStop()!= FMPE_OK)
              retval = -1;
		else if (FMPClose()!= FMPE_OK)
              retval = -1; 
		else if (MPEGDriverUnload()!= FMPE_OK)
              retval = -1;
            if(fd != -1)
		  close (fd);
		fd = -1;
            if (retval == -1)
              gMpegMode = MPEG_ERROR;
		else 
              gMpegMode = MPEG_CLOSE;
            mpegPlaying = 0;
		break;
/*
      case MPEG_STOP: 
		retval=FMPE_OK;	
		FMPStop();
                gMpegMode = MPEG_STOP;
		FMPClose(); 
		MPEGDriverUnload();
		close (fd);
		fd = -1;
                mpegPlaying = 0;
		break; 
*/
      case MPEG_PLAY: 
		retval=FMPE_OK;
		if (FMPPlay()!= FMPE_OK) {
                  retval = -1;
                  gMpegMode = MPEG_ERROR;
                } else {
                  gMpegMode = MPEG_PLAY;
                  mpegPlaying = 1;
                }
		break;
      case MPEG_PAUSE: 
		retval=FMPE_OK;
		if ( FMPPause()!= FMPE_OK) {
                   retval = -1;
                   gMpegMode = MPEG_ERROR;
                } else 
                   gMpegMode = MPEG_PAUSE;
	        break;
	case MPEG_START: 
  	     retval=FMPE_OK; 
	     switch(fileIndex)
	     {
	       default:
	         streamtype=FMPF_SYSTEM; 
                 retval = InitMPEGPlay(streamtype);
                 if (retval != -1)
		     fd=open("/cygnus/mpeg/clip1.mpg",O_RDONLY);
                 if (fd == -1){
                   printf("Cannot find file /cygnus/mpeg/clip1.mpg to play\n");
                   retval = -1;
                 } else 
	           fileIndex = 3;
	         break;
	       case 1:		
		  streamtype=FMPF_DVD;
		  retval = InitMPEGPlay(streamtype);
                  if(retval !=-1)
		   fd=open("/cygnus/sigma/bean_01_1.vob",O_RDONLY);
                  if (fd == -1){
                   printf("Cannot find file /cygnus/sigma/bean_01_1.vob to play\n");
                   retval = -1;
                  } else 
                     fileIndex = 2;
		  break;
		case 2:
		  streamtype=FMPF_TRANSPORT;
		  if (MPEGDriverEntry(NO_DRIVE)!= FMPE_OK){
                     printf("MPEG failed to load module/create driver\n");
                     retval = -1;
		  } else if (FMPSetVideoPortDimensions(resolutionX,resolutionY)
                     != FMPE_OK)
                  {
                    printf("FMPSetVideoPortDimensions error\n");
		    retval = -1;
                  } else if (FMPOpen(streamtype,64*1024,BUFFERCOUNT,NULL,0)!= FMPE_OK){
                    printf("Cannot open the MPEG driver\n");
		    retval = -1;
		  } else if ( FMPSet(FMPI_MUTE, 0)!= FMPE_OK){
                    printf("FMPSet error\n");
                    retval = -1;
                  } else if (FMPPlay()!= FMPE_OK){
                    printf("Cannot play, the driver is not open\n");
                    retval = -1;
                  }
                  if(retval !=-1)
		   fd=open("/cygnus/sigma/bean_01_1.vob",O_RDONLY);
                  if (fd == -1){
                     printf("Cannot find file /cygnus/sigma/BRAVHART.MPG to play\n");
                     retval = -1;
                  } else 
		   fileIndex = 2;
		  break;
		case 3:
		  streamtype=FMPF_SYSTEM; 
		  if(mode == 0)
		    fd=open("/cygnus/mpeg/clip1.mpg",O_RDONLY);  
		  else 
		  {
			streamtype=streamType; 
			fd=open(mpgFilename,O_RDONLY);
		  }
		  if(fd <= 0) {
                     printf("Cannot open /cygnus/mpeg/clip1.mpg file to play\n");
                     retval = -1;
		     break;
                  }
                  retval = InitMPEGPlay(streamtype);
                  if (retval == -1)
 		     break;
		  if ( FMPEnableFullScreen(1) != FMPE_OK) {
                       printf("Error in FMPEnableFullScreen call\n");
                       retval = -1;
                       break;
                  }
		  if(videostd == VIDEOSTD_PAL)
		  {
			FMPSet( FMPI_VIDEOOUT, FMPV_VIDEOOUT_TV);
			FMPSet( FMPI_VIDEOOUT, FMPV_VIDEOOUT_PAL);
		  }
		  FMPSetDestination(0,0,resolutionX,resolutionY);
		  fileIndex = 3;
		  break;
	       case 4:
		  streamtype=FMPF_SYSTEM; 
		  if(mode == 1)
		    fd=open("/cygnus/mpeg/clip2.mpg",O_RDONLY);  
		  else { 
			streamtype=streamType; 
			fd=open(mpgFilename,O_RDONLY);
		  }
		  if(fd <= 0) {
                     printf("Cannot open /cygnus/mpeg/clip1.mpg file to play\n");
		     retval = -1;
		     break;
                  }
		  retval = InitMPEGPlay(streamtype);
                  if (retval == -1)
 		    break;
                  if ( FMPEnableFullScreen(1) != FMPE_OK) {
                      printf("Error in FMPEnableFullScreen call\n");
                      retval = -1;
                      break;
                  }
		  if(videostd == VIDEOSTD_PAL) {
			FMPSet( FMPI_VIDEOOUT, FMPV_VIDEOOUT_TV);
			FMPSet( FMPI_VIDEOOUT, FMPV_VIDEOOUT_PAL);
		  }
		  FMPSetDestination(0,0,resolutionX,resolutionY);
		  fileIndex = 4;
		  break;
	      } //end of switch file index
	      if (fd<0) { 
		 StatusOutStr("could not open file to play\r\n"); 
		 break;
	      } 
	      if (retval != -1) {
                 gMpegMode = MPEG_PLAY;	
                 mpegPlaying = 1;
              } else 
                 gMpegMode = MPEG_ERROR;
	      break;
	
	case MPEG_UPDATE: 
            retval = FMPE_OK;
	    for(rdcount = 0; rdcount < 4  && retval==FMPE_OK; rdcount++)  
	    {
		if(bytesread) 
		{
			FMP_BUFFER FMPBuf;
			++readcount;
			if( FMPGetBuffer (&FMPBuf, FALSE) != FMPE_OK)
                           retval = -1;
			if (retval != FMPE_OK)
			{
		           //sprintf (tmp,"%d\r\n", readcount);
	                   //StatusOutStr(tmp);
                            gMpegMode = MPEG_ERROR;
			    readcount = 0;
			    return retval;
			}	
			while (((bytesread=read(fd,FMPBuf.pBuffer,
                                     FMPBuf.dwBufferSize)) == -1)
				     &&(errno==EINTR));
			if (bytesread <= 0 ) 
				bytesread=0;
			FMPBuf.dwDataSize = bytesread;
			if(bytesread != maxlog)
			{
				maxlog = bytesread;
				sprintf(tmp,"bytesread=%d\r\n", maxlog);
				StatusOutStr(tmp);
			}
			FMPPush (&FMPBuf);
		 }
		 if(!bytesread)
		 {
			lseek (fd,0,SEEK_SET);
			bytesread=1;
		 }
	     }
             gMpegMode = MPEG_PLAY;
             mpegPlaying = 1;
	     break;
	}
	return retval;
} 

/* ======================================================================== */
/* enable drawing the stripe pattern on the graphic screen */
void ShowPattern(int pattern)
{
	RECT rc;
	HWND itemhwnd = GetDlgItem(gPrefHwnd,IDC_PATTERN);
	int state = SendMessage(itemhwnd,BM_GETCHECK,0,0); 

	if(pattern >= 0)
		state = pattern;
	else if(pattern == -1) //toggle
		state = state ? 0:1;

	gPattern = state;
	SendMessage(itemhwnd,BM_SETCHECK,state,0);
	SetFocus(gDisplayHwnd);
	GetClientRect(gDisplayHwnd, &rc);
	InvalidateRect(gDisplayHwnd,&rc,TRUE);
	
}

/* enable dvip mode */
void SetDVIP(int showdvip)
{

	HWND itemhwnd = GetDlgItem(gPrefHwnd,IDC_DVIP);
	int state = SendMessage(itemhwnd,BM_GETCHECK,0,0); 
        int retval = 0;

	if(showdvip >= 0)
		state = showdvip;
	else if(showdvip == -1) //toggle
		state = state ? 0:1;
        if(gScaleVideo)
           state = 0;
	if(state)
	{
		retval = dvip(1);
	}
	else  
	{
		retval = dvip(0);
	}
        if (retval == -1) state=0;
	SendMessage(itemhwnd,BM_SETCHECK,state,0);
	SetFocus(gDisplayHwnd);
	
}

/* enable the menu bar display
   use alpha blend to make transitions */
void ShowMenuBar(int show)
{
	int colormode;
	RECT panelRect1 = { 0,0,resolutionX,80 };
	RECT panelRect2 = { 27+menuoffsetX,37,456+menuoffsetX,63 };
	POINT p1 = {0,0};
	POINT p2 = {0,0};
	HWND itemhwnd = GetDlgItem(gPrefHwnd,IDC_CINEMA);
	int state = SendMessage(itemhwnd,BM_GETCHECK,0,0);
	if(show >= 0)
		state = show;
	else if(show == -1) //toggle
		state = state ? 0:1;
	
	if(gScaleVideo)
	{
		SetAlphaBlend(alpha1,panelRect1,0,-1,0,0);
		SetAlphaBlend(alpha2,panelRect2,0,-1,0,0);
		SetAlphaBlend(alpha0,panelRect2,0,-1,0,0);
	}
	else if(state)
	{
		colormode = gVidSelection ? 0 : 0x0100FF00;
		SetAlphaBlend(alpha1,panelRect1,colormode,0x50,p1.x,p1.y);
		SetAlphaBlend(alpha2,panelRect2,0,0xFF,p2.x,p2.y);
	
	}
	else
	{
		SetAlphaBlend(alpha1,panelRect1,0,0x00FF50,p1.x,p1.y);
		SetAlphaBlend(alpha2,panelRect2,0,0x00FFFF,p2.x,p2.y);
	}
	SendMessage(itemhwnd,BM_SETCHECK,state,0);
}
