/*
 * National Semiconductor Corporation Gnu General Public License for 
 *
 *    VTest4Linux
 *
 * (GPL License with Export Notice)
 *
 * Copyright (c) 2001 
 * National Semiconductor Corporation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted under the terms of the GNU General 
 * Public License as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later version  
 *
 * In addition to the terms of the GNU General Public License, neither 
 * the name of the National Semiconductor Corporation nor the names of 
 * its contributors may be used to endorse or promote products derived 
 * from this software without specific prior written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * NATIONAL SEMICONDUCTOR CORPORATION OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
 * GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
 * IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE, 
 * INTELLECTUAL PROPERTY INFRINGEMENT, OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
 * OF SUCH DAMAGE. See the GNU General Public License for more details. 
 *
 * EXPORT LAWS: THIS LICENSE ADDS NO RESTRICTIONS TO THE EXPORT LAWS OF 
 * YOUR JURISDICTION. It is licensee's responsibility to comply with 
 * any export regulations applicable in licensee's jurisdiction. Under 
 * CURRENT (June 22, 2001>) U.S. export regulations this software 
 * is eligible for export from the U.S. and can be downloaded by or 
 * otherwise exported or reexported worldwide EXCEPT to U.S. embargoed 
 * destinations which include Cuba, Iraq, Libya, North Korea, Iran, 
 * Syria, Sudan, Afghanistan and any other country to which the U.S. 
 * has embargoed goods and services. 
 *
 * You should have received a copy of the GNU General Public License 
 * along with this file; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 */

#ifndef _VTEST_H_
#define _VTEST_H_


#define TRUE 		1
#define FALSE 		0

/* video standard */

#define VIDEOSTD_NTSC  	0
#define VIDEOSTD_PAL 	1

/* video input selection */

#define VID_TUNER 	0
#define VID_COMPOSITE	1
#define VID_SVIDEO 	2
#define VID_DIGITAL	3

/* alpha window id */
#define alpha0 		0
#define alpha1 		1
#define alpha2 		2

/* overlay attributes */
#define OVERLAY_KEY 	0x00f000f0
#define OVERLAY_MASK 	0x00f0f0f0

/* mpeg operations */
#define MPEG_CLOSE      0
#define MPEG_STOP	1
#define MPEG_START	2
#define MPEG_UPDATE	3
#define MPEG_PLAY	4
#define MPEG_PAUSE	5
#define MPEG_ERROR	6


/* window classes */
#define APPCLASS	"vtest"
#define PREFCHILD	"panel"
#define STATUSCHILD	"status"
#define DISPLAYCHILD	"display"

/* items ID */
#define IDC_GROUP1	11
#define	IDC_GROUP2	12
#define	IDC_GROUP3	13
#define IDC_GROUP4	14
#define IDC_GROUP5	15

#define IDC_TUNER	0x202 
#define IDC_VIDEO	0x200 
#define IDC_SVIDEO	0x201
#define IDC_DIGITAL	0x203
#define IDC_STREAM	0x204
#define IDC_PREF	0x205
#define IDC_CHNUM10x	0x206
#define IDC_CHNUM1x	0x207
#define IDC_PANLEFT	0x307 
#define IDC_PANCENTER	0x308 
#define IDC_PANRIGHT	0x309 
#define IDC_STATUSWND	0x401
#define IDC_MUTE	0x402
#define IDC_CLOSECAPTION 0x403 
#define IDC_VOLUMEUP	0x404 
#define IDC_VOLUMEDOWN	0x405 
#define IDC_CLOSEPREF	0x407
#define IDC_LOGO	0x408 
#define IDC_SCALE	0x409 
#define IDC_EXIT	0x40A 
#define IDC_FULLSCREEN	0x506 
#define IDC_DEBUGDUMP	0x507 
#define IDC_CINEMA	0x509 
#define IDC_DVIP	0x50A
#define IDC_STATUS	0x600
#define IDC_PREFPANEL	0x601 
#define IDC_DISPLAY	0x602
#define IDC_PATTERN	0x701
/* timer */
#define mainTimerID	999

/* color button bitmap */
extern MWIMAGEHDR image_tv8a; 
extern MWIMAGEHDR image_video8;
extern MWIMAGEHDR image_svideo8;
extern MWIMAGEHDR image_digital8;
extern MWIMAGEHDR image_mpeg8;
extern MWIMAGEHDR image_pref8;

/* channel number display */
extern MWIMAGEHDR image_0;
extern MWIMAGEHDR image_1;
extern MWIMAGEHDR image_2;
extern MWIMAGEHDR image_3;
extern MWIMAGEHDR image_4;
extern MWIMAGEHDR image_5;
extern MWIMAGEHDR image_6;
extern MWIMAGEHDR image_7;
extern MWIMAGEHDR image_8;
extern MWIMAGEHDR image_9;
extern MWIMAGEHDR image_blank;

/* logo */
extern MWIMAGEHDR image_nsc8;
#define LOGOX	320
#define LOGOY	360

/* status window */
#define COLS		58
#define ROWS		6
#define STATUSMARGIN_X	4
#define STATUSMARGIN_Y	2

/* Close Caption display */
#define CCDISPLAY_W 	32
#define CCDISPLAY_H 	15
#define CCLEFT		80
#define CCTOP		180
#define CC_POP 		1
#define CC_PAINT	0
#define CC_RU2 		2
#define CC_RU3 		3
#define CC_RU4 		4
#define CCBKCOLOR	BLACK

/* local command and debug */
#define READ_VIP	2
#define WRITE_VIP	3
#define READ_REG	4
#define WRITE_REG	5
#define READ_DEC	6
#define WRITE_DEC	7
#define READ_VID	8
#define WRITE_VID	9


/* prototypes */
/* window event handlers */
LRESULT CALLBACK MainWndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK PrefWndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK StatusWndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK DisplayWndProc(HWND hwnd,UINT uMsg,WPARAM wp,LPARAM lp);

/* driver wrapper */
int dvip(int enable);
int video_set_control(unsigned long id,unsigned char value);
int ChangeShapness(int amount);
int video_brightness(unsigned char bright);
int video_contrast(unsigned char contrast);
int video_saturation(unsigned char sat);
int video_hue(unsigned char hue);
int video_sharpness(unsigned char sharp);
int open_devices();
int close_devices();
int get_vout_format(int * width, int* height) ;
int set_color_key(unsigned long key, unsigned long mask);
int set_graphic_on_video(int enable, int color_key_src);
int set_alpha_window(unsigned char num, unsigned short x, unsigned short y,
			unsigned short width, unsigned short height);
int set_alpha_operation(unsigned char num, unsigned char alpha, 
			unsigned long color, int color_enable, 
			int priority, char fade, int enable);
int set_video_outside_alpha(int enable);
int set_overlay_info( unsigned long key, unsigned long mask, int graphics, 
			int enable);
int set_alpha_blend_info(int window, int x, int y, int w, int h, 
			  int priority, int alpha, int delta, int enable,
			  unsigned long color);
int set_video_fmt(int width, int height);
int set_vout_window(int x, int y, int width, int height);
int set_input(int inp);
int capture_enable( int enable);
int preview(int enable);
int set_chan(int ch);
int set_vout_control(int val);

/* driver interface */
int SetAlphaBlend(int wnum,RECT rc,int subcolor,int alphaval,int xoffs,int yoffs);
int OpenVideo();
int CloseVideo();
void EmOutChar(HWND hwnd, int ch);
int  CreatePtyShell(void);
int  ReadPtyShell(int fd, char *buf, int count);
int  WritePtyShell(int fd, char *buf, int count);
void ClosePtyShell(int fd);
int  SetChannel(int chnum);
void StatusOutStr(LPCSTR str);
int  decode_cc();
void CCRollup(int line, int baserow);
void SetRollup(int lastmode,int newmode, int baserow,int channel);
void CCOutChar(int ch, int row, int col, int channel, BOOL bDraw);

/* Close caption display */
void stopvbi();
int CheckCC();

/* gui operations */
#define ITEM_APPLY -2
#define ITEM_TOGGLE -1
#define ITEM_ON 1
#define ITEM_OFF 0

int ShowCloseCaption(int show);
int ShowScale(int scale);
int SetLogo(int state);
void ShowStatus(int show);
void ShowPref(int show);
void ShowMenuBar(int show);
void SetDVIP(int enable);
void ShowPattern(int enable);

int SelectVideoSource(int cmdShow, int selection, int mode);
int SetAudio(int selection,int mute, int incr);
int InitMPEGPlay(int StreamType);
int PlayMpeg(int cmd,int mode);

#endif
