#include "NXPicture.h"
#include "objects.h"

extern char XBILL_HOME[256];

NXPicture::~NXPicture()
{
  if (gc)
    GrDestroyGC(gc);

  if (image)
    GrFreeImage(image);

  if (pixmap)
    GrDestroyWindow(pixmap);
}

void NXPicture::load(char *name, int index=-1) {
	GR_IMAGE_INFO iinfo;
	char file[255];

	if (index>=0)
	  sprintf (file, "%s%s_%d.xpm", XBILL_HOME, name, index);
	else 
	  sprintf(file, "%s%s.xpm", XBILL_HOME, name);
	
	/* Ok, load the pix */
	image = GrLoadImageFromFile(file, 0);

	if (image)
	  {
	    GrGetImageInfo(image, &iinfo);
	    
	    width = iinfo.width;
	    height = iinfo.height;
	    
	    /* Create a new pixmap for off screen drawing */
	    
	    
	    pixmap = GrNewPixmap(width + 3, height + 3, NULL);       
	    gc = GrNewGC();
	    
	    GrSetGCBackground(gc, WHITE);
	    GrFillRect(pixmap, gc, 0, 0, width, height);
	    
	    /* And draw our boy there */
	    GrDrawImageToFit(pixmap, gc, 0, 0,
			     width, height,
			     image);
	  }
}
