/*
 * vertex.h - vertex header file 
 *
 * Copyright (C) 2000 by Century Software 
 * Truman Lackey <trumanl@censoft.com>
 *
 */

#ifndef vertex_h
#define vertex_h
#endif

#include "nano-X.h"

typedef short COORD_T;

struct matrix{ double a, b, c, d, x, y;};

void push_matrix();
void pop_matrix();
void mult_matrix(double a, double b, double c, double d, double x, double y);
void scale_xy(double x, double y);
void scale_x(double x);
void translate(double x, double y);
void rotate(double d);
void begin_points();
void begin_line();
void begin_loop();
void begin_polygon();
double transform_x(double x, double y);
double transform_y(double x, double y);
double transform_dx(double x, double y);
double transform_dy(double x, double y);
void transformed_double_vertex(double xf, double yf);
void vertex(double x, double y);
void end_points(GR_WINDOW_ID pmap, GR_GC_ID gc);
void end_line(GR_WINDOW_ID pmap, GR_GC_ID gc);
void end_loop(GR_WINDOW_ID pmap, GR_GC_ID gc);
void end_polygon(GR_WINDOW_ID pmap, GR_GC_ID gc);
void begin_complex_polygon();
void fgap();
void end_complex_polygon(GR_WINDOW_ID pmap, GR_GC_ID gc);
void circle(double x, double y, double r, GR_WINDOW_ID pmap, GR_GC_ID gc, GR_SIZE w, GR_SIZE h);

