/*
 * IPAQ_PROTO.C
 * Copyright 2000, Century Software Embedded Technologies
 */

/* 
 * DESCRIPTION:  This file fills out the prototype structure
 *               for the Compaq Ipaq.  
 *               
 * AUTHOR:       First draft, Jordan Crouse, 11/27/00
 */

/* Include files for NXSYS functions */
#include "nxsys.h"
#include "nxsys_proto.h"
#include "linux.h"
#include "ads.h"

/* Include files for NXCOMM functions */
#include "nxcomm_proto.h"
#include "nxcomm.h"
#include "linux_if.h"
#include "linux_ppp.h"

/* NXSYS includes */
#include "nxio_protos.h"
#include "sound_dsp.h"

/* NXSYS */
nxsys_func_t nxsys_functions = {  
  linux_set_date,               /* set date */
  linux_get_date,               /* get date */
  ads_set_backlight,           /* set backlight */
  linux_get_cpu_load,           /* get CPU load */
  linux_get_memory_usage,       /* Get memory usage */
  NXSYS_NOT_IMPLEMEMNTED        /* Get battery */
};

/* NXCOMM */
nxcomm_func_t nxcomm_functions = {  
  linux_set_ip_address,         /* set ip address */
  linux_get_ip_address,         /* get ip address */
  linux_add_default_gateway,    /* Add gateway */
  linux_remove_default_gateway, /* Remove gateway */
  ads_set_nameserver,          /* Set the name server */
  /* linux_ppp_connect,         */   /* Connect a PPP session */ 
  linux_ppp_disconnect,         /* Disconnect a PPP session */
  linux_get_if_list,             /* Get a list of interfaces */
  linux_if_active,
  linux_ppp_get_stats,
  linux_ppp_write_info,
  linux_ppp_read_info
};

/* NXIO FUNCTIONS */
nxio_functions_t nxio_functions = {
  dspPlayWAVFile                       /* Play a WAV file */
};
