#ifndef NXCOMM_PROTO_H
#define NXCOMM_PROTO_H

/*
 * NXCOMM_PROTO.H
 * Copyright 2000, Century Software Embedded Technologies
 */

/* 
 * DESCRIPTION:  This file defines the prototype structure
 *               used to define the system dependent functions
 *               that must be called for each API function
 *
 * AUTHOR:       First draft, Jordan Crouse, 11/27/00
 */

/****** THIS FILE IS FOR INTERNAL LIBRARY USE ONLY ******/

#include "nxcomm.h"

#define NXCOMM_PROTO_NO_FUNCTION 0x0 /* Use this when no function is available */

typedef struct _nxcommproto
{
  int (*sysdep_do_ip_address)(int, char *, nxcomm_ipaddr_t *);
  int (*sysdep_do_default_gateway)(int, unsigned long *, char *);
  int (*sysdep_set_nameserver)(char *, char *, unsigned long *, int);
  int (*sysdep_ppp_connect)(int, nxcomm_ppp_options_t *, char **, int, int, char *); 
  int (*sysdep_ppp_disconnect)(char *);
  int (*sysdep_get_if_list)(int, nxcomm_interface_t *, int *);
  int (*sysdep_if_active)(char *);
  int (*sysdep_set_if_status)(int, char *);
  int (*sysdep_if_dhcp)(char *);
  int (*sysdep_ppp_get_stats)(char *, nxcomm_ppp_stats_t *);
  int (*sysdep_ppp_write_info)(char *, nxcomm_ppp_info_t *);
  int (*sysdep_ppp_read_info)(char *, nxcomm_ppp_info_t *);
  int (*sysdep_ppp_get_ip_info)(char *, nxcomm_ppp_options_t *);
  int (*sysdep_wireless_essid)(int, char *, char *);
  int (*sysdep_wireless_get_stats)(char *, nxcomm_wirestats_t *);
  int (*sysdep_wireless_get_if_list)(nxcomm_interface_t *, int *);
  int (*sysdep_get_net_value)(char *, char *);
  int (*sysdep_write_net_values)(nxcomm_ipaddr_str_t, nxcomm_dns_t);
} nxcomm_func_t;

#endif
