/*
 * NXSCRTOP_API.C
 * Copyright 2000, Century Software Embedded Technologies
 */

/* 
 * DESCRIPTION:  This file contains the API for communcating
 *               with the NXSCRTOP
 *               
 * AUTHOR:       First draft, Jordan Crouse, 11/27/00
 */


/* These are the static commands that the 
   actually communicate with the screen top 
*/

char *pid_locations[] = 
{ "/var/run/",
  "/tmp/",
  0
}

static int find_nxscrtop()
{
  int count = 0;

  /* First, look for the pid file in the locations specified */
  /* in the array */

  while(pid_locations[count])
    {
      char path[256];
      struct stat fstat;

      sprintf(path, "%s/nxscrtop.pid", pid_locations[count]);
      
      if (stat(path, &fstat) != -1)
	{
	  int pid;
	  char buf[10];
	  int fd = open(path, R_RDONLY);

	  if (fd == -1)
	    return(-1);

	  /* Read the file and get the PID */
	  len = read(fd, buf, sizeof(buf));
	  close(fd);

	  if (len == -1)
	    return(-1);

	  if ((pid = atoi(buffer)) == 0)
	    return(-1);

	  /* Now, get the key */

	  if ((key = ftok(path, (pid & 0xFF))) == -1)
	    return(-1);

	  /* Now, return the queue identifier */
	  ret = msgget(key, 0);

	  if (ret == -1)
	    if (errno == ENOENT)
	      return(-2);

	  return(ret);
	}
      count++;
    }

  return(-2);
}


	  
static int nxscrtop_send_command(int class, char *data)
{
  /* This makes a key to communicate with the screentop */
  
  int client = find_nxscrtop();

  if (client == -2)
    return(NXSCRTOP_NOT_ACTIVE);

  if (client == -1)
    return(NXSCRTOP_IPC_ERROR);

  
}

static int nxscrtop_send_request(int class, char *data, char *resp)
{
}

/* These are the functions that send various commands */
/* to the screen top */

int nxscrtop_set_catagory(int catagory)
{
}

int nxscrtop_register_applet()
{
}





