/* SOUND.C

   Library:       nxIO - IO Library
   Description:  Public sound control functions
   Author:       Jordan Crouse

   Copyright 2000, Century Software Embedded Technologies
*/

#include "nxio.h"
#include "nxio_protos.h"

extern nxio_functions_t nxio_functions;

int nxio_play_soundfile(int type, char *filename)
{
  switch (type)
    {
    case NXIO_WAV_FILE:
      if (nxio_functions.sysdep_play_wav_file)
	return(nxio_functions.sysdep_play_wav_file(filename));
      else
	return(NXIO_NOT_IMPLEMENTED);
      break;

    default:
      return(NXIO_NOT_IMPLEMENTED);
    }
}

int nxio_save_sound_file(int type, char *filename, nxio_audio_t *settings, 
			 unsigned char *buffer)
{
  switch (type)
    {
    case NXIO_WAV_FILE:
      if (nxio_functions.sysdep_save_wav_file)
	return(nxio_functions.sysdep_save_wav_file(filename, settings, buffer));
      else
	return(NXIO_NOT_IMPLEMENTED);
      break;

    default:
      return(NXIO_NOT_IMPLEMENTED);
    }
}

int nxio_load_sound_file(int type, char *filename, nxio_audio_t *settings, 
			 unsigned char *buffer, int size)
{
  switch (type)
    {
    case NXIO_WAV_FILE:
      if (nxio_functions.sysdep_load_wav_file)
	return(nxio_functions.sysdep_load_wav_file(filename, settings, buffer, size));
      else
	return(NXIO_NOT_IMPLEMENTED);
      break;

    default:
      return(NXIO_NOT_IMPLEMENTED);
    }
}

int nxio_open_stream(int direction, nxio_audio_t *settings)
{
  if (nxio_functions.sysdep_open_stream)
    return(nxio_functions.sysdep_open_stream(direction, settings));
  else
    return(NXIO_NOT_IMPLEMENTED);
}

int nxio_stream_record(int fd, unsigned char *buffer, int size)
{
   if (nxio_functions.sysdep_stream_record)
    return(nxio_functions.sysdep_stream_record(fd, buffer, size));
  else
    return(NXIO_NOT_IMPLEMENTED);
}

int nxio_stream_play(int fd, unsigned char *buffer, int size)
{
   if (nxio_functions.sysdep_stream_play)
    return(nxio_functions.sysdep_stream_play(fd, buffer, size));
  else
    return(NXIO_NOT_IMPLEMENTED);
}

int nxio_get_wav_stats(char *filename, nxio_audio_t *settings)
{
   if (nxio_functions.sysdep_get_wav_stats)
    return(nxio_functions.sysdep_get_wav_stats(filename, settings));
  else
    return(NXIO_NOT_IMPLEMENTED);
}

int nxio_get_mixer_devices(unsigned long *bitmask)
{
  if (nxio_functions.sysdep_get_mixer_devices)
    return(nxio_functions.sysdep_get_mixer_devices(bitmask));
  else
    return(NXIO_NOT_IMPLEMENTED);
}

int nxio_set_mixer_level(int device, nxio_level_t *level)
{
  if (nxio_functions.sysdep_set_mixer_level)
    return(nxio_functions.sysdep_set_mixer_level(device, level));
  else
    return(NXIO_NOT_IMPLEMENTED);
}

int nxio_get_mixer_level(int device, nxio_level_t *level)
{
  if (nxio_functions.sysdep_get_mixer_level)
    return(nxio_functions.sysdep_get_mixer_level(device, level));
  else
    return(NXIO_NOT_IMPLEMENTED);
}
