#ifndef SOUND_DSP_H
#define SOUND_DSP_H

#define WAVE_MONO	1
#define WAVE_STEREO	2

/* Wave header */
typedef struct
{
  unsigned long main_chunk;
  unsigned long length;
  unsigned long chunk_type;

  unsigned long sub_chunk;
  unsigned long sc_len;
  unsigned short format;
  unsigned short modus;
  unsigned long spd;
  unsigned long bytes_per_sec;
  unsigned short bytes_per_sample;
  unsigned short bits_per_sample;
  unsigned long data_chunk;
  unsigned long datalen;
} dspWaveHeader;


int dspOpenStream(int direction, nxio_audio_t *settings);
int dspStreamRecord(int fd, unsigned char *buffer, int size);
int dspStreamPlay(int fd, unsigned char *buffer, int size);

int dspGetWAVFileStats(char *filename, nxio_audio_t *settings);
int dspWriteWAVFile(char *filename, nxio_audio_t *settings, unsigned char *buffer);
int dspReadWAVFile(char *filename, nxio_audio_t *settings, unsigned char *buffer, int size);

int dspPlayWAVFile(char *filename);

int mixer_get_devices(unsigned long *);
int mixer_set_level(int, nxio_level_t *);
int mixer_get_level(int, nxio_level_t *);

#endif
