/*
 * IPAQ_PROTO.C
 * Copyright 2000, Century Software Embedded Technologies
 */

/* 
 * DESCRIPTION:  This file fills out the prototype structure
 *               for the Compaq Ipaq.  
 *               
 * AUTHOR:       First draft, Jordan Crouse, 11/27/00
 */

/* NXSYS includes */

#include "nxsys_proto.h"
#include "nxsys.h"
#include "linux.h"

/* NXCOMM includes */

#include "nxcomm_proto.h"
#include "nxcomm.h"
#include "linux_if.h"
#include "linux_ppp.h"
#include "linux_wireless.h"
#include "x86.h"

/* NXSYS includes */
#include "nxio.h"
#include "nxio_protos.h"
#include "sound_dsp.h"

nxsys_func_t nxsys_functions = {  
  linux_set_date,               /* set date */
  linux_get_date,               /* get date */
  NXSYS_PROTO_NO_FUNCTION,      /* set backlight */
  linux_get_cpu_load,           /* get CPU load */
  linux_get_memory_usage,       /* Get memory usage */
  NXSYS_PROTO_NO_FUNCTION,      /* Get battery */
  x86_get_net_value,
  x86_write_net_values
};

nxcomm_func_t nxcomm_functions = {  
  linux_do_ip_address,         /* handle ip address */
  linux_do_default_gateway,    /* handle gateway */
  x86_set_nameserver,          /* Set the name server */
  linux_ppp_connect,   		    /* Connect a PPP session */ 
  linux_ppp_disconnect,        /* Disconnect a PPP session */
  linux_get_if_list,           /* Get a list of interfaces */
  linux_if_active,
  linux_set_if_status,
  linux_if_dhcp,
  linux_ppp_get_stats,
  linux_ppp_write_info,
  linux_ppp_read_info,
  linux_ppp_ip_address, 
  wireless_essid,
  wireless_get_statistics,
  wireless_get_if_list
};

/* NXIO FUNCTIONS */
nxio_functions_t nxio_functions = {
  dspPlayWAVFile,                      /* Play a WAV file */
  dspWriteWAVFile,
  dspReadWAVFile,
  dspGetWAVFileStats,
  dspOpenStream,
  dspStreamRecord,
  dspStreamPlay,
  mixer_get_devices,
  mixer_get_level,
  mixer_set_level
};
  
