/***********************************************************************
*                                                                      *
* COPYRIGHT (c) 2000   Century Software   All Rights Reserved          *
*                                                                      *
* This software is the property of Century Software and shall not be   *
* reproduced or copied in whole or  used in whole or in  part as the   *
* basis for the manufacture or sale of items, nor shall such copy be   *
* sold or constitute part of a sale without written permission.        *
*                                                                      *
* RESTRICTED RIGHTS LEGEND                                             *
*                                                                      *
* Use, duplication,  or disclosure by the government is subject to     *
* restriction as set forth in paragraph (b)(3)(b) of the Rights in     *
* Technical Data and Computer Software clause in DAR 7-104.9(a).       *
*                                                                      *
* CENTURY SOFTWARE                                                     *
* 5284 SOUTH 320 WEST - SUITE C-134                                    *
* MURRAY, UTAH   84107                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* FILENAME: cmdblock.h                                                 *
*                                                                      *
***********************************************************************/
#ifndef CMDBLOCK_H
#define CMDBLOCK_H



/*
**
** Imported "Include" Files
**
*/



/*
**
** Global Constant Definitions
**
*/
#define SM_FILENAME "/tmp/.smid.wm"
#define MAX_BUF_LEN 256



/*
**
** Global Enumeration Definitions
**
*/
typedef enum
{
  WMSTATUS_IDLE,
  WMSTATUS_START,
  WMSTATUS_BUSY,
  WMSTATUS_DONE,
  WMSTATUS_LAST
}WMStatus;

typedef enum
{
  WMCMD_NONE,
  WMCMD_NOOP,
  WMCMD_MPEG_STOP,
  WMCMD_MPEG_PLAY,
  WMCMD_MPEG_PAUSE,
  WMCMD_VIEWER_OBJECT_REFRESH,  // parm1: name of object to be refreshed
  WMCMD_VIEWER_FRAME_LOAD,      // parm1: name of frame to be loaded
                                // parm2: name of HTML page to load
// Values for NetStream Playback
  WMCMD_STR_FWD,
  WMCMD_STR_PLAY,
  WMCMD_STR_PAUSE,
  WMCMD_STR_REV,
  WMCMD_STR_STOP,
  WMCMD_STR_LOOP,
  WMCMD_STR_MUTE,
  WMCMD_STR_LEFTAUDIO,
  WMCMD_STR_RIGHTAUDIO,
  WMCMD_STR_CONNECT,
  WMCMD_STR_DISCONNECT,
  WMCMD_STR_QUIT,

  WMCMD_DVD_FWD,
  WMCMD_DVD_PLAY,
  WMCMD_DVD_PAUSE,
  WMCMD_DVD_REV,
  WMCMD_DVD_STOP,
  WMCMD_DVD_LOOP,
  
  WMCMD_SET_TIME,

  WMCMD_EXIT,	
  WMCMD_LAST
}WMCmd;



/*
**
** Global Structure Definitions
**
*/
typedef struct
{
  int status;
  int command;
  char parm1[MAX_BUF_LEN];
  char parm2[MAX_BUF_LEN];
  int parm3;
  int parm4;
}WMCmdBlock;

#endif /* CMDBLOCK_H */
