/***********************************************************************
*                                                                      *
* COPYRIGHT (c) 2000   Century Software   All Rights Reserved          *
*                                                                      *
* This software is the property of Century Software and shall not be   *
* reproduced or copied in whole or  used in whole or in  part as the   *
* basis for the manufacture or sale of items, nor shall such copy be   *
* sold or constitute part of a sale without written permission.        *
*                                                                      *
* RESTRICTED RIGHTS LEGEND                                             *
*                                                                      *
* Use, duplication,  or disclosure by the government is subject to     *
* restriction as set forth in paragraph (b)(3)(b) of the Rights in     *
* Technical Data and Computer Software clause in DAR 7-104.9(a).       *
*                                                                      *
* CENTURY SOFTWARE                                                     *
* 5284 SOUTH 320 WEST - SUITE C-134                                    *
* MURRAY, UTAH   84107                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* FILENAME: OVERLAY.H                                                  *
*                                                                      *
***********************************************************************/
#ifndef OVERLAY_H
#define OVERLAY_H



/*
**
** Imported "Include" Files
**
*/



/*
**
** Global Constant Definitions
**
*/



/*
**
** Global Enumeration Definitions
**
*/



/*
**
** Global Structure Definitions
**
*/



/*
**
** Global Variable Declarations
**
*/



/*
**
**  NAME: VAPIOverlayOpen()
**
** USAGE: int VAPIOverlayOpen(void);
**
** DESCR: This function will initialize this module and prepare it for
**        operation.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
** NOTES: This funciton must be called before any other functions in this
**        module are called.
**
*/
int VAPIOverlayOpen(void);



/*
**
**  NAME: VAPIOverlayClose()
**
** USAGE: int VAPIOverlayClose(void);
**
** DESCR: This function will close this module and return any used memory
**        to the system.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int VAPIOverlayClose(void);



/*
**
**  NAME: VAPIOverlaySelect()
**
** USAGE: int VAPIOverlaySelect(void);
**
** DESCR: This function will enable the video overlay operation.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int VAPIOverlaySelect(void);



/*
**
**  NAME: VAPIOverlayDisable()
**
** USAGE: int VAPIOverlayDisable(void);
**
** DESCR: This function will disable the video overlay operation.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int VAPIOverlayDisable(void);



/*
**
**  NAME: VAPIOverlayPosition()
**
** USAGE: int VAPIOverlayPosition(int xpos,
**                                  int ypos,
**                                  int width,
**                                  int height);
**
** DESCR: This function will position the overlay window on the screen at
**        the specified position and size.
**
** PARMS: The "xpos" parameter specifies the horizontal position of the 
**        overlay window. The "ypos" parameter specifies the vertical
**        position of the overlay window. The "width" parmater specifies
**        the width of the overlay window. The "height" paramter specifies
**        the height of the overlay window.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int VAPIOverlayPosition(int, int, int, int);

int debugOverlay(int, int, int, int, int, int, int, int, int, int);

#endif /* OVERLAY_H */

