/***********************************************************************
*                                                                      *
* COPYRIGHT (c) 2000   Century Software   All Rights Reserved          *
*                                                                      *
* This software is the property of Century Software and shall not be   *
* reproduced or copied in whole or  used in whole or in  part as the   *
* basis for the manufacture or sale of items, nor shall such copy be   *
* sold or constitute part of a sale without written permission.        *
*                                                                      *
* RESTRICTED RIGHTS LEGEND                                             *
*                                                                      *
* Use, duplication,  or disclosure by the government is subject to     *
* restriction as set forth in paragraph (b)(3)(b) of the Rights in     *
* Technical Data and Computer Software clause in DAR 7-104.9(a).       *
*                                                                      *
* CENTURY SOFTWARE                                                     *
* 5284 SOUTH 320 WEST - SUITE C-134                                    *
* MURRAY, UTAH   84107                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* FILENAME: SRCTUNER.H                                                 *
*                                                                      *
***********************************************************************/
#ifndef SRCTUNER_H
#define SRCTUNER_H


/*
**
** Imported "Include" Files
**
*/



/*
**
** Global Constant Definitions
**
*/



/*
**
** Global Enumeration Definitions
**
*/



/*
**
** Global Structure Definitions
**
*/



/*
**
** Global Variable Declarations
**
*/



/*
**
**  NAME: VAPISrcTunerSelect()
**
** USAGE: int VAPISrcTunerSelect(void);
**
** DESCR: This function will select the tuner source as the system video
**        source.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int VAPISrcTunerSelect(void);



/*
**
**  NAME: VAPISrcTunerChannelSet()
**
** USAGE: int VAPISrcTunerChannelSet(int channel);
**
** DESCR: This function will set the tuner to the specified channel.
**
** PARMS: The "channel" parameter specifies the tuner channel.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
int VAPISrcTunerChannelSet(int);

#endif /* SRCTUNER_H */
