/***********************************************************************
*                                                                      *
* COPYRIGHT (c) 2000   Century Software   All Rights Reserved          *
*                                                                      *
* This software is the property of Century Software and shall not be   *
* reproduced or copied in whole or  used in whole or in  part as the   *
* basis for the manufacture or sale of items, nor shall such copy be   *
* sold or constitute part of a sale without written permission.        *
*                                                                      *
* RESTRICTED RIGHTS LEGEND                                             *
*                                                                      *
* Use, duplication,  or disclosure by the government is subject to     *
* restriction as set forth in paragraph (b)(3)(b) of the Rights in     *
* Technical Data and Computer Software clause in DAR 7-104.9(a).       *
*                                                                      *
* CENTURY SOFTWARE                                                     *
* 5284 SOUTH 320 WEST - SUITE C-134                                    *
* MURRAY, UTAH   84107                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* FILENAME: STATUS.H                                                   *
*                                                                      *
***********************************************************************/
#ifndef STATUS_H
#define STATUS_H



/*
**
** Imported "Include" Files
**
*/



/*
**
** Global Constant Definitions
**
*/
#define STATUSMODE_SILENT 0x0
#define STATUSMODE_SCREEN 0x1
#define STATUSMODE_FILE 0x2



/*
**
** Global Enumeration Definitions
**
*/



/*
**
** Global Structure Definitions
**
*/



/*
**
** Global Variable Declarations
**
*/



/*
**
**  NAME: VAPIStatusOpen()
**
** USAGE: int VAPIStatusOpen(int mode);
**
** DESCR: This function will open and initialize this module.
**
** PARMS: The "mode" parameter specifies how the status text will be
**        displayed, and is selected from the StatusMode enumeration.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
** NOTES: This function must be called before any other functions in this
**        module are called.
**
*/
extern "C"
int VAPIStatusOpen(int);




/*
**
**  NAME: VAPIStatusClose()
**
** USAGE: int VAPIStatusClose(void);
**
** DESCR: This function will close this module and return any allocated
**        memory back to the system.
**
** PARMS: None.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
extern "C"
int VAPIStatusClose(void);




/*
**
**  NAME: VAPIStatusOutStr()
**
** USAGE: int VAPIStatusOutStr(char *str);
**
** DESCR: This function will output the specified string to all active
**        status devices.
**
** PARMS: The "str" parameter is a pointer to a buffer that contains the
**        text to be output.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
extern "C"
int VAPIStatusOutStr(char *);



/*
**
**  NAME: VAPIStatusOutVal()
**
** USAGE: int VAPIStatusOutVal(int value);
**
** DESCR: This function will output the specified value to all active
**        status devices.
**
** PARMS: The "value" parameter contains the value to be output.
**
** RETRN: If successful, '0' is returned. If an error occurs during function
**        execution, a non-zero value is returned that describes the error.
**
*/
extern "C"
int VAPIStatusOutVal(int);

#endif /* STATUS_H */

