/***********************************************************************
*                                                                      *
* COPYRIGHT (c) 2000   Century Software   All Rights Reserved          *
*                                                                      *
* This software is the property of Century Software and shall not be   *
* reproduced or copied in whole or  used in whole or in  part as the   *
* basis for the manufacture or sale of items, nor shall such copy be   *
* sold or constitute part of a sale without written permission.        *
*                                                                      *
* RESTRICTED RIGHTS LEGEND                                             *
*                                                                      *
* Use, duplication,  or disclosure by the government is subject to     *
* restriction as set forth in paragraph (b)(3)(b) of the Rights in     *
* Technical Data and Computer Software clause in DAR 7-104.9(a).       *
*                                                                      *
* CENTURY SOFTWARE                                                     *
* 5284 SOUTH 320 WEST - SUITE C-134                                    *
* MURRAY, UTAH   84107                                                 *
*                                                                      *
************************************************************************
*                                                                      *
* FILENAME: main.cpp                                                   *
*                                                                      *
***********************************************************************/



/*
**
** Imported "Include" Files
**
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <anlg_video.h>
#include "cmdutil.h"
#include "dispatcher.h"
#include "errorbase.h"
#include "plugin.h"
#include "sharedclient.h"
#include "state.h"
#include "status.h"



/*
**
** Local Variable Declarations
**
*/



/*
**
** Local Constant Definitions
**
*/
#define		WRAPPER_APP_NAME		"vidwinctrl"
#define		WRAPPER_APP_PATH		"/bin/vidwinctrl"
#define		WRAPPER_LOCK_FILE		"/var/lock/vidwinctrl.lck"

/*
**
** Local Enumeration Definitions
**
*/



/*
**
** Local Structure Definitions
**
*/



/*
**
** Local Variable Declarations
**
*/



/*
**
**
**
*/
int main(int argc, char *argv[])
{
  char buf[1024];
  int count,result;

  //VMW_AVS_VideoInit();
  // verify the shared memory block is created
  if(clientMemoryCreate() < 0)
  {
    printf("Unable to allocate shared memory...\n");
    exit(1);
  }

  // attach to the shared memoyr block
  if(clientMemoryAttach() != 0)
  {
    printf("Unable to attach to shared memory...\n");
    exit(1);
  }

  // load the current state
  loadState();

  // load the plugins
  loadPlugins("/bin");
  if(plugin_list_len == 0)
  {
    printf("No valid plugins found...\n");
    saveState();
    clientMemoryDetach();
    exit(1);
  }
    
  VMW_AVS_VideoClose();
  // check for help
  if(argc == 1)
  {
    result = dispatcher("help");
    unloadPlugins();
    saveState();
    clientMemoryDetach();
    exit(0);
  }

  // enable status output to the screen
  VAPIStatusOpen(STATUSMODE_FILE);

  // prepare command line
  buf[0] = 0x00;
  count = 1;
  do
  {
    strcat(buf,argv[count]);
    strcat(buf," ");
  }while(++count < argc);
  buf[strlen(buf) - 1] = 0x00;

  // execute the command
  result = dispatcher(buf);

  // do housekeeping
  VAPIStatusClose();

  // unload the plugins
  unloadPlugins();

  // save the current state
  if(saveState() != 0)
    exit(ERRORBASE_SYSTEM + 1);
  
  // detach from shared memory
  clientMemoryDetach();

  
  // exit with no errors
  exit(result);
}

